#ifndef COPYNG_H
#define COPYNG_H

#include <QThread>
#include <QMessageBox>
#include <QTime>
#include <QDir>
#include <QProcess>
#include <QCryptographicHash>
#include <QTimer>
#include <QEventLoop>
#include <QDirIterator>

#ifdef Q_OS_WIN
#include <qt_windows.h>
#include <Aclapi.h>
#endif 

#include <QStandardItemModel>

class ThreadCopy: public QThread
{
	Q_OBJECT
public:
	ThreadCopy(QObject *parent=0);
	~ThreadCopy();
	void dostart();
	void setData (const QString &NameTask_, const QStringList &Source_, const QString &Destination_, const qint64 &IndexThread_, const bool &create_additional_dir_, 
		const QString &additional_dir_name_, const bool &cleardest_, const bool &notRewrite_, const bool &reWrite_, const bool &exDate_, const QString &ex_Date_Copy_, 
		const int &condition_, const QStandardItemModel &ext_, const QStandardItemModel &files_, const QStandardItemModel &dirs_,const bool &exSize_, 
		const int &condition_2_, const qint64 &ex_Size_Copy_, const int &sizeCombo_, const int &do_before_, 
		const QString &execute_before_,  const QString &execute_before_cmd_, const QString &execute_before_dir_, const int &do_after_, 
		const QString &execute_after_, const QString &execute_after_cmd_, const QString &execute_after_dir_, const int &cmp_md5_, const bool &ext_log_, 
		const bool &viewMessages_, const bool &clear_log_, const bool &stream_waiting_, const bool &copy_empty_dir_);

	void stop();
	QString getlasterror();
	qint64 getindex();
	QStringList getlog();

protected:
	void run();
	QStringList my_log;
	static  const int BUFFSIZE = 64*1024; //   ?????
	char buff[BUFFSIZE];

private:
	volatile bool stopped;
	volatile qint64 IndexThread;
	volatile bool create_additional_dir, cleardest, notRewrite, reWrite, exDate, exSize, do_before, 
		do_after, do_cmp_md5, ext_log, viewMessages, clear_log, stream_waiting, copy_empty_dir;
	QString additional_dir_name,ex_Date_Copy;
	volatile qint64 copy_files_size, ex_Size_Copy, total_current_file_bytes_writeln;
	volatile int condition, condition_2, sizeCombo;
	volatile double percent;
	QString NameTask, prefix;
	QStringList Source;
	QString Destination, execute_before, execute_before_cmd, execute_before_dir, execute_after, execute_after_cmd, execute_after_dir, Start_Dest, err_source, err_dest;
	QStandardItemModel ext, files, dirs;
	bool copyData(QIODevice& src, QIODevice& dest);
	void copyFile_Bl(const QString &source, const QString &target);
	void deleteFile(const QString &filename);
	void cleardir(const QString &dirname);
	qint64 GetFilesSize_win(const QString &);
	qint64 GetFilesSize_qt(const QString &);
	void GetAllFilesSize();
	void copydir(const QString &, const QString &);
	bool doexcludecopy(const QString &, const QStandardItemModel &, const QStandardItemModel &, const QStandardItemModel &);
	bool doincludecopy(const QString &, const QStandardItemModel &, const QStandardItemModel &, const QStandardItemModel &);
	bool doexcludecopy_dir(const QString &, const QStandardItemModel &);
	bool doincludecopy_dir(const QString &, const QStandardItemModel &);
	bool cmp_md5(const QString &, const QString &);
	QString replace_text(QString sour);
	QStringList dir_entryList_files(const QString &);
	QStringList dir_entryList_dirs(const QString &);
	QProcess myprocess;
	QString decodeFileError(QFile::FileError Code);

	private slots:
		void do_stopped_();

	
signals:
	void setTaskStatus(qint64, const QString &, const bool &);
	void save_thread_log(qint64 indextable, const QStringList & text_log);
	void setPercent(qint64, double);
	void thread_stopped(qint64);
	void WriteLnConsole(const QString &);
};

#endif