#include "copying.h"
//#include "fileutils.h"

const int BUFFSIZE = 64*1024; //   ?????
char buff[BUFFSIZE];

ThreadCopy::ThreadCopy(QObject *parent):QThread(parent)
{
	stopped = false;
	copy_files_size = 0;
	percent = 0;
	connect(this, SIGNAL(finished ()), this, SLOT(do_stopped_()));
}

ThreadCopy::~ThreadCopy()
{
	stopped = true;
}

void ThreadCopy::do_stopped_()
{
	mutex.lock();
	emit thread_stopped(IndexThread);
	mutex.unlock();
	wait();
}

QString ThreadCopy::getlasterror()
{
	LPWSTR err = L"";
	DWORD iderr = GetLastError();
	FormatMessage(FORMAT_MESSAGE_ALLOCATE_BUFFER | FORMAT_MESSAGE_FROM_SYSTEM,NULL, iderr, 0, (LPWSTR)&err, 0, NULL);
	if (iderr == 0)
		err = L"";
	return QString::fromStdWString(err).trimmed();	
}

void ThreadCopy::setData(const QString &NameTask_, const QStringList &Source_, const QString &Destination_, const qint64 &IndexThread_, const bool &create_additional_dir_, 
	const QString &additional_dir_name_, const bool &cleardest_, const bool &notRewrite_, const bool &reWrite_, const bool &exDate_, const QString &ex_Date_Copy_, 
	const int &condition_, const QStandardItemModel &ext_, const QStandardItemModel &files_, const QStandardItemModel &dirs_,const bool &exSize_, 
	const int &condition_2_, const qint64 &ex_Size_Copy_, const int &sizeCombo_, const int &do_before_, 
	const QString &execute_before_,  const QString &execute_before_cmd_, const QString &execute_before_dir_, const int &do_after_, 
	const QString &execute_after_, const QString &execute_after_cmd_, const QString &execute_after_dir_, const int &cmp_md5_, const bool &ext_log_, 
	const bool &viewMessages_, const bool &clear_log_, const bool &stream_waiting_, const bool &copy_empty_dir_)
{	
	NameTask = NameTask_;
	Source = Source_;
	Destination = Destination_;
	Start_Dest = Destination_;
	IndexThread = IndexThread_;
	create_additional_dir = create_additional_dir_;
	additional_dir_name = additional_dir_name_;
	cleardest = cleardest_;
	notRewrite = notRewrite_;
	reWrite = reWrite_;
	exDate = exDate_;
	ex_Date_Copy = ex_Date_Copy_;
	condition = condition_;
	exSize = exSize_;
	condition_2 = condition_2_;
	ex_Size_Copy = ex_Size_Copy_;
	sizeCombo = sizeCombo_;
	do_before = do_before_;
	execute_before = execute_before_;
	execute_before_dir = execute_before_dir_;
	execute_before_cmd = execute_before_cmd_;
	do_after = do_after_;
	execute_after = execute_after_;
	execute_after_cmd = execute_after_cmd_;
	execute_after_dir = execute_after_dir_;
	do_cmp_md5 = cmp_md5_;
	ext_log = ext_log_;
	viewMessages = viewMessages_;
	clear_log = clear_log_;
	stream_waiting = stream_waiting_;
	copy_empty_dir = copy_empty_dir_;
	
	ext.clear();
	files.clear();
	dirs.clear();

	ext.setColumnCount(ext_.columnCount());
	files.setColumnCount(files_.columnCount());
	dirs.setColumnCount(dirs_.columnCount());

	for (int i = 0; i < ext_.rowCount(); i++)
	{
		ext.insertRow(0);
		ext.setData(ext.index(0,0),ext_.data(ext_.index(i,0)).toString());
		ext.setData(ext.index(0,1),ext_.data(ext_.index(i,1)).toInt());
	}

	for (int i = 0; i < files_.rowCount(); i++)
	{
		files.insertRow(0);
		files.setData(files.index(0,0),files_.data(files_.index(i,0)).toString());
		files.setData(files.index(0,1),files_.data(files_.index(i,1)).toInt());
	}

	for (int i = 0; i < dirs_.rowCount(); i++)
	{
		dirs.insertRow(0);
		dirs.setData(dirs.index(0,0),dirs_.data(dirs_.index(i,0)).toString());
		dirs.setData(dirs.index(0,1),dirs_.data(dirs_.index(i,1)).toInt());
	}
}


bool ThreadCopy::doexcludecopy(const QString &sourname, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs)
{	
	
	for (int i=0;i<ext.rowCount();i++) //   
	{				
		if (ext.data(ext.index(i,1)).toInt() == 1) //    "   " ()
		{			
			QRegExp rx_ext(ext.data(ext.index(i,0)).toString());
			rx_ext.setPatternSyntax(QRegExp::Wildcard);
			if (rx_ext.exactMatch(QFileInfo(sourname).fileName()))
				return true;
		}		
	}

	for (int i=0;i<files.rowCount();i++) //   
	{				
		if (files.data(files.index(i,1)).toInt() == 1) //    "   " ()
		{						
			if (QDir::toNativeSeparators(sourname) == files.data(files.index(i,0)).toString())
				return true;
		}		
	}

	for (int i=0;i<dirs.rowCount();i++) //  
	{				
		if (dirs.data(dirs.index(i,1)).toInt() == 1) //    "   " ()
		{						
			if (QDir::toNativeSeparators(sourname).indexOf(dirs.data(dirs.index(i,0)).toString()) == 0)
			{
				if (QDir::toNativeSeparators(sourname).at(dirs.data(dirs.index(i,0)).toString().size()) == '\\')
					return true;
			}
		}		
	}

	return false;
}

bool ThreadCopy::doexcludecopy_dir(const QString &dirname, const QStandardItemModel &dirs) //    ( )
{
	for (int i=0;i<dirs.rowCount();i++) //  
	{				
		if (dirs.data(dirs.index(i,1)).toInt() == 1) //    "   " ()
		{						
			if (dirname.indexOf(dirs.data(dirs.index(i,0)).toString()) == 0)
			{
				if (dirname.size() == dirs.data(dirs.index(i,0)).toString().size() || QDir::toNativeSeparators(dirname).at(dirs.data(dirs.index(i,0)).toString().size()) == '\\')		
					return true;
			}
		}		
	}
	return false;
}

bool ThreadCopy::doincludecopy(const QString &sourname, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs)
{
	bool filter_Tag = false;

	for (int i=0;i<ext.rowCount();i++) //   
	{				
		if (ext.data(ext.index(i,1)).toInt() == 2) //    "  " ()
		{			
			filter_Tag = true;
			QRegExp rx_ext(ext.data(ext.index(i,0)).toString());
			rx_ext.setPatternSyntax(QRegExp::Wildcard);
			if (rx_ext.exactMatch(QFileInfo(sourname).fileName()))
				return true; // , 
		}		
	}

	for (int i=0;i<files.rowCount();i++) //   
	{				
		if (files.data(files.index(i,1)).toInt() == 2) //    "  " ()
		{						
			filter_Tag = true;
			if (QDir::toNativeSeparators(sourname) == files.data(files.index(i,0)).toString())
				return true; // , 
		}		
	}

	for (int i=0;i<dirs.rowCount();i++) //  
	{				
		if (dirs.data(dirs.index(i,1)).toInt() == 2) //    "  " ()
		{						
			filter_Tag = true;
			if (QDir::toNativeSeparators(sourname).indexOf(dirs.data(dirs.index(i,0)).toString()) == 0) //lastindexof ???
			{
				if (QDir::toNativeSeparators(sourname).at(dirs.data(dirs.index(i,0)).toString().size()) == '\\')
				return true; // , 
			}
		}		
	}

	if (filter_Tag)
		return false; // ,    ,  
	else
		return true; //  ,  
}


bool ThreadCopy::doincludecopy_dir(const QString &dirname, const QStandardItemModel &dirs)
{
	bool filter_Tag = false;

	for (int i=0;i<dirs.rowCount();i++) //  
	{				
		if (dirs.data(dirs.index(i,1)).toInt() == 2) //    "  " ()
		{						
			filter_Tag = true;
			if (dirname.indexOf(dirs.data(dirs.index(i,0)).toString()) == 0) //lastindexof ???
			{	
				if (dirname.size() == dirs.data(dirs.index(i,0)).toString().size() || QDir::toNativeSeparators(dirname).at(dirs.data(dirs.index(i,0)).toString().size()) == '\\')		
				return true; // , 
			}
		}		
	}

	if (filter_Tag)
		return false; // ,    ,  
	else
		return true; //  ,  
}


void ThreadCopy::deleteFile(const QString &filename)
{
#if defined(Q_OS_LINUX)
	{
		if (!QFile().setPermissions(filename,QFile::ReadOwner|QFile::WriteOwner|QFile::ExeOwner|QFile::ReadGroup|QFile::ExeGroup|QFile::ReadOther|QFile::ExeOther))			
		{
			emit setTaskStatus(IndexThread, " "+NameTask+".      "+filename,true);
			return;
		}
	}
#elif defined(Q_OS_WIN)
	{
		if (::SetNamedSecurityInfo((wchar_t*)QString(filename).utf16(), SE_FILE_OBJECT, DACL_SECURITY_INFORMATION, NULL, NULL, NULL, NULL) != ERROR_SUCCESS)
		{	mutex.lock();
			emit setTaskStatus(IndexThread, " "+NameTask+".      "+filename,true,false);
			mutex.unlock();
			wait();
			return;
		}

		if (!::SetFileAttributes((wchar_t*)QString(filename).utf16(),FILE_ATTRIBUTE_NORMAL))
		{
			mutex.lock();
			emit setTaskStatus(IndexThread, " "+NameTask+".    "+filename,true,false);
			mutex.unlock();
			wait();
			return;
		}
	}
#endif

	if (!QFile().remove(filename))
	{	
		mutex.lock();
		emit setTaskStatus(IndexThread, " "+NameTask+".   "+filename+" "+getlasterror(),true,false);
		mutex.unlock();
		wait();
		return;
	}               
}

bool ThreadCopy::cmp_md5(const QString &source, const QString &target)
{
	QByteArray buf( 65536, ' ' ), hashSource, hashTarget;
	qint64 bytesread;
	QCryptographicHash hash(QCryptographicHash::Md5);
	QFile s(source);
	QFile t(target);

	if (s.size() == 0 && t.size() == 0)
		return true;

	if (!s.open(QIODevice::ReadOnly))
	{
		mutex.lock();
		emit setTaskStatus(IndexThread, " "+NameTask+".   "+source,true,false);
		mutex.unlock();
		wait();
		return false;
	}

	if (!t.open(QIODevice::ReadOnly))
	{
		mutex.lock();
		emit setTaskStatus(IndexThread, " "+NameTask+".   "+target,true,false);
		mutex.unlock();
		wait();
		s.close();
		return false;
	}

	bytesread = s.read(buf.data(), buf.size());	
	if (buf.size() > 0) //   
	{
		while (bytesread > 0)
		{
			hash.addData(buf.data(),bytesread);
			bytesread = s.read( buf.data(), buf.size() );
		}
	}

	s.close();
	hashSource = hash.result();

	hash.reset();

	bytesread = t.read(buf.data(), buf.size());
	if (buf.size() > 0) //   
	{
		while (bytesread > 0)
		{
			hash.addData(buf.data(),bytesread);
			bytesread = t.read( buf.data(), buf.size() );
		}
	}

	t.close();
	hashTarget = hash.result();

	if (hashSource == hashTarget)
		return true;
	else
		return false;
}


void ThreadCopy::copyFile_Bl(const QString& source, const QString& target) // 
{	     

	if (stopped)
		return;

	     if ((source.isEmpty()) || (target.isEmpty()))
		 {
			 mutex.lock();
			 emit setTaskStatus(IndexThread," "+NameTask+".      ", true,false);
			 mutex.unlock();
			 wait();
			 return;
		 }

	     if (source == target)
		 {
		     mutex.lock();
			 emit setTaskStatus(IndexThread," "+NameTask+".   =   !!!", true,false);    
			 mutex.unlock();
			 wait();
			 return;
		 }
		 
		 QFileInfo fileinfo_s(source);
	     QFile s(source);

		 QFile t;
		 if (target.lastIndexOf("\\") == target.size()-1)
		 t.setFileName(target+fileinfo_s.fileName());
		 else
		 t.setFileName(target+QDir::separator()+fileinfo_s.fileName());

	     if (!s.exists() && !fileinfo_s.isSymLink())
		 {
				 mutex.lock();    
				 emit setTaskStatus(IndexThread," "+NameTask+".   "+source, true,false);
				 mutex.unlock();
				 wait();
				 return;
		 }


/*       */	     	
if (t.exists() && notRewrite) 
// "   "
{
	if (copy_files_size !=0)
	{
		percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
		mutex.lock();
		emit setPercent(IndexThread, percent);
		mutex.unlock();
		wait();
	}
return;
}

if (doexcludecopy(source, ext, files, dirs)) 
//  "    (, , )"
{
	if (copy_files_size !=0)
	{
		percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
		mutex.lock();
		emit setPercent(IndexThread, percent);
		mutex.unlock();
		wait();
	}
	return;
}

if (!doincludecopy(source, ext, files, dirs))
//  "   (, , )"
{
	if (copy_files_size !=0)
	{
		percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
		mutex.lock();
		emit setPercent(IndexThread, percent);
		mutex.unlock();
		wait();
	}
	return;
}

if (t.exists() && do_cmp_md5)
		//  ,     MD5
	{
		if (!reWrite && cmp_md5(source, t.fileName()))
		{
			if (copy_files_size !=0)
			{
				percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				mutex.lock();
				emit setPercent(IndexThread, percent);
				mutex.unlock();
				wait();
			}
			return;
		}
	}


if (t.exists() && !do_cmp_md5)
	//  ,    MD5
{
	QFileInfo fileinfo_d(t.fileName());
	if ((fileinfo_d.lastModified() == fileinfo_s.lastModified())  && (fileinfo_d.size() == fileinfo_s.size()) && !reWrite) 
	//        =  ,    "   "

	{
		if (copy_files_size !=0)
		{
			percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
			mutex.lock();
			emit setPercent(IndexThread, percent);
			mutex.unlock();
			wait();
		}

		return;
	}
}

if (exDate) //  "      >, <, ="
	{		
		QDate ex_date = QDate::fromString(ex_Date_Copy,"dd.MM.yyyy");

		if (!ex_date.isValid())
		{
			
			if (copy_files_size !=0)
			{
				percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				mutex.lock();
				emit setPercent(IndexThread, percent);
				mutex.unlock();
				wait();
			}
			
			mutex.lock();
			emit setTaskStatus(IndexThread," "+NameTask+".     ",true,false);
			mutex.unlock();
			wait();
			return;
		}

		switch (condition)
		{
		case 0:			
				if (fileinfo_s.lastModified().date() < ex_date)
				{
					if (copy_files_size !=0)
					{
						percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
						mutex.lock();
						emit setPercent(IndexThread, percent);
						mutex.unlock();
						wait();
					}
				return;		
				}			
			break;

		case 1:			
				if (fileinfo_s.lastModified().date() > ex_date)
				{
					if (copy_files_size !=0)
					{
						percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
						mutex.lock();
						emit setPercent(IndexThread, percent);
						mutex.unlock();
						wait();
					}
				return;		
				}			
			break;

		case 2:			
				if (fileinfo_s.lastModified().date() == ex_date)
				{
					if (copy_files_size !=0)
					{
						percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
						mutex.lock();
						emit setPercent(IndexThread, percent);
						mutex.unlock();
						wait();
					}
				return;
				}			
			break;
		}
	}

if (exSize) //  "     >, <, ="
{
	int multiplier = 1;

	if (sizeCombo == 0)
		multiplier = 1;  // sizeCombo   
	else
		if (sizeCombo == 1)
			multiplier = 1024;
		else
			if (sizeCombo == 2)
				multiplier = 1048576;
			else
				if (sizeCombo == 3)
					multiplier = 1073741824;

	switch (condition_2)
	{
	case 0:			
		if (fileinfo_s.size() < (ex_Size_Copy*multiplier))
		{
			if (copy_files_size !=0)
			{
				percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				mutex.lock();
				emit setPercent(IndexThread, percent);
				mutex.unlock();
				wait();
			}
			return;		
		}			
		break;
	case 1:			
		if (fileinfo_s.size() > (ex_Size_Copy*multiplier))
		{
			if (copy_files_size !=0)
			{
				percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				mutex.lock();
				emit setPercent(IndexThread, percent);
				mutex.unlock();
				wait();
			}
			return;		
		}			
		break;
	case 2:			
		if (fileinfo_s.size() == (ex_Size_Copy*multiplier))
		{
			if (copy_files_size !=0)
			{
				percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				mutex.lock();
				emit setPercent(IndexThread, percent);
				mutex.unlock();
				wait();
			}
			return;		
		}			
		break;
	}

}
/*       */

		 if (!QDir().exists(target)) 
		 {
			 if (!QDir().mkpath(target))
			 {
				 if (copy_files_size !=0)
				 {
					 percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
					 mutex.lock();
					 emit setPercent(IndexThread, percent);
					 mutex.unlock();
					 wait();
				 }
				 
				 mutex.lock();
				 emit setTaskStatus(IndexThread," "+NameTask+".   "+target,true,false);
				 mutex.unlock();
				 wait();
				 return;
			 }
		 }
		
		 if (!::SetFileAttributes((wchar_t*)QString(target).utf16(),::GetFileAttributes((wchar_t*)QString(fileinfo_s.absolutePath()).utf16())))
		 {
		     mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".    "+target,true,false);
			 mutex.unlock();
			 wait();
		 }

		 if (t.exists())		 
			 deleteFile(t.fileName());	         

		 HANDLE hSrc = ::CreateFile(QDir::convertSeparators(source).utf16(), GENERIC_READ, FILE_SHARE_READ | FILE_SHARE_WRITE, 0, OPEN_EXISTING, 0, 0);
		 if (hSrc == INVALID_HANDLE_VALUE)
		 {
			 if (copy_files_size !=0)
			 {
				 percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				 mutex.lock();
				 emit setPercent(IndexThread, percent);
				 mutex.unlock();
				 wait();
			 }

			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".   "+source+" "+getlasterror(),true,false);
			 mutex.unlock();
			 wait();
			 return;
		 }

		 HANDLE hTgt = ::CreateFile(QDir::convertSeparators(t.fileName()).utf16(), GENERIC_WRITE, 0, NULL, CREATE_ALWAYS, 0, 0);
		 if (hTgt == INVALID_HANDLE_VALUE)
		 {
			 if (copy_files_size !=0)
			 {
				 percent+=(fileinfo_s.size() * 100.0) / copy_files_size;
				 mutex.lock();
				 emit setPercent(IndexThread, percent);
				 mutex.unlock();
				 wait();
			 }

			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".   "+t.fileName()+" "+getlasterror(),true,false);
			 mutex.unlock();
			 wait();
			 return;
		 }

		 if (viewMessages) 
			 emit WriteLnConsole(NameTask + " : " + source); 

		 if (ext_log)
			 emit setTaskStatus(IndexThread, " " + source, false,true);

		 bool success = false;
		 DWORD read = 0;
		 DWORD byteswritten = 0;
		 //ZeroMemory( &buff, sizeof(buff) );
		 memset(&buff,0,sizeof(buff));
		 
		 while (ReadFile (hSrc, buff, BUFFSIZE, &read, 0) && read && !stopped)
		 {
			     success = WriteFile (hTgt, buff, read, &byteswritten, 0);

				 if (copy_files_size != 0)
				 {
					 percent+=(byteswritten * 100.0) / copy_files_size;
					 mutex.lock();
					 emit setPercent(IndexThread, percent);
					 mutex.unlock();
					 wait();
				 }

				 success  &= (read == byteswritten);
				 if (!success)
				 {
					 LPCWSTR path = target.utf16();
				 ULARGE_INTEGER FreeBytesAvailable;
				 ULARGE_INTEGER TotalNumberOfBytes;
				 ULARGE_INTEGER TotalNumberOfFreeBytes;
				 GetDiskFreeSpaceEx( path, &FreeBytesAvailable, &TotalNumberOfBytes, &TotalNumberOfFreeBytes );
				 qint64 bytesAvailable = FreeBytesAvailable.QuadPart;

				 if (bytesAvailable <= read)
				 {				 
				 
				 emit setTaskStatus(IndexThread, " "+NameTask+".   (    ).   : "+t.fileName()+" "+getlasterror(),true,false);
				 
				 }
				 else
				 {
					 
					 emit setTaskStatus(IndexThread, " "+NameTask+".  .   : "+t.fileName()+" "+getlasterror(),true,false);
					 
				 }

				 CloseHandle (hSrc);
				 CloseHandle (hTgt);
				 deleteFile(t.fileName());	
				 return;
				 }
		 }
		 
		 QString err = getlasterror();
		 if (!err.isEmpty() || stopped)
		 {
			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".  ,   .   : "+t.fileName()+" "+err,true,false);
			 mutex.unlock();
			 wait();
			 CloseHandle (hSrc);
			 CloseHandle (hTgt);
			 deleteFile(t.fileName());	
			 return;
		 }
		 
		  FILETIME creationTime, accessTime, writeTime;

		  if (::GetFileTime(hSrc, &creationTime, &accessTime, &writeTime)) 
		  {

			  if (!::SetFileTime(hTgt, &creationTime, &accessTime, &writeTime))
			  {
				  mutex.lock();
				  emit setTaskStatus(IndexThread, " "+NameTask+".    "+t.fileName(),true,false);
				  mutex.unlock();
				  wait();
			  }
		  }
		  else
		  {
			  mutex.lock();
			  emit setTaskStatus(IndexThread, " "+NameTask+".    "+source,true,false);
			  mutex.unlock();
			  wait();
		  }

		 CloseHandle (hSrc);
		 CloseHandle (hTgt);

		 if (!::SetFileAttributes((wchar_t*)QString(t.fileName()).utf16(),::GetFileAttributes((wchar_t*)(source.utf16()))))
		 {
			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".    "+t.fileName(),true,false);
			 mutex.unlock();
			 wait();
		 }
}

void ThreadCopy::cleardir(const QString &dirname)
{
	if (stopped)
		return;

	QDir dir (dirname);

	foreach (QString file, dir_entryList_files(dirname))
    {				
		if (stopped) 
			return;

		if (QFileInfo(dir.absolutePath()+QDir::separator()+file).isFile() || QFileInfo(dir.absolutePath()+QDir::separator()+file).isSymLink())	//   4.7.4 ( - entryList        QDir::Hidden)	
			deleteFile(dir.absolutePath()+QDir::separator()+file);								
    }

	foreach (QString subDir, dir_entryList_dirs(dirname))
	{
		cleardir(dirname+QDir::separator()+subDir);

		if (!::SetFileAttributes((wchar_t*)QString(dirname+QDir::separator()+subDir).utf16(),FILE_ATTRIBUTE_NORMAL))
		{
			mutex.lock();
			emit setTaskStatus(IndexThread, " "+NameTask+".    "+dirname+QDir::separator()+subDir,true,false);
			mutex.unlock();
			wait();
			return;
		}

		if (!QDir().rmdir(dirname+QDir::separator()+subDir))
		{
			mutex.lock();
			emit setTaskStatus(IndexThread, " "+NameTask+".   "+ dirname+QDir::separator()+subDir+" "+getlasterror(), true,false);	
			mutex.unlock();
			wait();
			return;
		}
	}
}

void ThreadCopy::copydir(const QString &Source, const QString &Destination)
{
	
	if (stopped)
		    return;

		if (Source == Destination)
		{
			   mutex.lock();   
			   emit setTaskStatus(IndexThread, " "+NameTask+".   =  ",true,false);
			   mutex.unlock();
			   wait();
			   return;
		}
	
	QDir dir (Source);

	if (!dir.exists())
	{
		mutex.lock();    
		emit setTaskStatus(IndexThread," "+NameTask+".      "+Source, true,false);
		mutex.unlock();
		wait();
		return;
	}

	//foreach (QString file, dir.entryList(QDir::Files | QDir::Hidden | QDir::System)) //  ???
	foreach (QString file, dir_entryList_files(Source))
	{				
		
		if (stopped) 
			return;
		
		if (QFileInfo(dir.absolutePath()+QDir::separator()+file).isFile() || QFileInfo(dir.absolutePath()+QDir::separator()+file).isSymLink())		
			copyFile_Bl(dir.absolutePath()+QDir::separator()+file, Destination);		
	}

	//foreach (QString subDir, dir.entryList(QDir::NoDotAndDotDot|QDir::Dirs| QDir::Hidden))
	foreach (QString subDir, dir_entryList_dirs(Source))
	{		
		if (stopped) 
			return;
		
		if (QFileInfo(Source+QDir::separator()+subDir).isDir())
		{						
			
			if (copy_empty_dir)
			if (!QDir().exists(Destination+QDir::separator()+subDir)) 
			{				
				if (!doexcludecopy_dir(Source+QDir::separator()+subDir,dirs) && (doincludecopy_dir(Source+QDir::separator()+subDir,dirs))) 
					//       
				{
					if (!QDir().mkpath(Destination+QDir::separator()+subDir))
				  {
					mutex.lock();
					emit setTaskStatus(IndexThread, " "+NameTask+".   "+Destination+QDir::separator()+subDir,true,false);
					mutex.unlock();
					wait();
					return;
				  }
					 
			if (!::SetFileAttributes((wchar_t*)QString(Destination+QDir::separator()+subDir).utf16(),::GetFileAttributes((wchar_t*)QString(Source+QDir::separator()+subDir).utf16())))
			{
			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".    "+Destination+QDir::separator()+subDir,true,false);
			 mutex.unlock();
			 wait();
			}
			
				}
			}

			copydir(Source+QDir::separator()+subDir, Destination+QDir::separator()+subDir);
		}
	}
}

qint64 ThreadCopy::GetFilesSize_qt(const QString &path)
{
	if (stopped)
		return 0;    

	if (QFileInfo(path).isFile())				
		return QFileInfo(path).size();

	qint64 size = 0;
	QDir dir(path);

	foreach (QString file, dir.entryList(QDir::Files | QDir::Hidden | QDir::System))
	{
		if (stopped) return 0;
		size += QFileInfo(dir, file).size();
	}

	foreach (QString subDir, dir.entryList(QDir::NoDotAndDotDot|QDir::Dirs| QDir::Hidden))
	{
		if (stopped) return 0;
		size += GetFilesSize_qt(path + QDir::separator() + subDir);
	}
	return size;
}

qint64 ThreadCopy::GetFilesSize_win(const QString &dir)
{
	if (stopped)
		return 0; 

	bool findlnk = false;
	
	if (QFileInfo(dir).isFile())				
		return QFileInfo(dir).size();
	
	 qint64 size = 0; 
	 WIN32_FIND_DATA finfo = {0};  
	 HANDLE hFind = FindFirstFile(QDir::convertSeparators(dir+"\\*").utf16(), &finfo);

	  if (hFind  != INVALID_HANDLE_VALUE)    
	  {
		  do 
		{
			if (lstrcmp(finfo.cFileName, L".") != 0 && lstrcmp(finfo.cFileName, L"..") != 0 )				
		    {   			
				if (finfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)
				{
					if (finfo.dwFileAttributes & FILE_ATTRIBUTE_REPARSE_POINT) // 
						findlnk = true;
					else
						findlnk = false;

					if (!findlnk)			
						size += GetFilesSize_win(dir+"\\"+QString::fromStdWString(finfo.cFileName));
					
				}
			  else			   
				  size += ((DWORDLONG)finfo.nFileSizeHigh<<32) + finfo.nFileSizeLow;			  
	        }
		}
		while (!stopped && FindNextFile(hFind, &finfo)); 
		FindClose(hFind); 		 
	  }

	  else
	  {
	      mutex.lock();
		  emit setTaskStatus(IndexThread, " "+NameTask+"   (  ): " + dir,true,false);
		  mutex.unlock();
		  wait();
	  }
		  return size;
}

QStringList ThreadCopy::dir_entryList_files(const QString &dir)
{
	QStringList files_list;
	WIN32_FIND_DATA finfo = {0}; 
	HANDLE hFind = FindFirstFile(QDir::convertSeparators(dir+"\\*").utf16(), &finfo);

	if (hFind  != INVALID_HANDLE_VALUE)    
	{
		do 
		{
			if (lstrcmp(finfo.cFileName, L".") != 0 && lstrcmp(finfo.cFileName, L"..") != 0 )				
			{   			
				if (finfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)				
					continue;						   
					files_list.append(QString::fromStdWString(finfo.cFileName));
			}
		}
		while (!stopped && FindNextFile(hFind, &finfo)); 
		FindClose(hFind); 		 
	}
	else
	{
		mutex.lock();
		emit setTaskStatus(IndexThread, " "+NameTask+"   (  ): " + dir,true,false);
		mutex.unlock();
		wait();
	}
		return files_list;
}

QStringList ThreadCopy::dir_entryList_dirs(const QString &dir)
{
	QStringList dirs_list;
	WIN32_FIND_DATA finfo = {0}; 
	HANDLE hFind = INVALID_HANDLE_VALUE;

	hFind = FindFirstFile(QDir::convertSeparators(dir+"\\*").utf16(), &finfo);
	if (hFind  != INVALID_HANDLE_VALUE)    
	{
		do 
		{
			if (lstrcmp(finfo.cFileName, L".") != 0 && lstrcmp(finfo.cFileName, L"..") != 0 )				
			{   			
				if (finfo.dwFileAttributes & FILE_ATTRIBUTE_DIRECTORY)				
				dirs_list.append(QString::fromStdWString(finfo.cFileName));
			}
		}
		while (!stopped && FindNextFile(hFind, &finfo)); 
		FindClose(hFind); 		 
	}
	else
	{
		mutex.lock();
		emit setTaskStatus(IndexThread, " "+NameTask+"   (  ): " + dir,true,false);
		mutex.unlock();
		wait();
	}
	    return dirs_list;
}

void ThreadCopy::GetAllFilesSize()
{
	copy_files_size = 0;
	percent = 0;

#if defined(Q_OS_LINUX)
	{
		foreach (QString sourcedata, Source )
		{
			if (viewMessages)
				emit WriteLnConsole(NameTask + "  : " + sourcedata);

	    copy_files_size+=GetFilesSize_qt(sourcedata); //  
		}
	}
#elif defined(Q_OS_WIN)
	{
		foreach (QString sourcedata, Source )
		{
			if (viewMessages)
			{
				mutex.lock();
				emit WriteLnConsole(NameTask + "  : " + sourcedata);
				mutex.unlock();
				wait();
			}

		copy_files_size += GetFilesSize_win(sourcedata);
		}
	}

#endif

}

QString ThreadCopy::replace_text(QString sour)
{
	int index = 0;
	QStringList keywordPatterns;
	keywordPatterns << "<-dir>"<<"<-date>"<<"<-time>";
	foreach (const QString &pattern, keywordPatterns) //   
	{
		if (pattern == "<-dir>")
		{
			index = sour.indexOf(pattern);
			while (index >= 0)
			{
				int length = pattern.size();
				sour.replace(index, length, Destination);
				index = sour.indexOf(pattern, index + Destination.size());
			}
		}
		else
			if (pattern == "<-date>")
			{
				index = sour.indexOf(pattern);
				while (index >= 0)
				{
					int length = pattern.size();
					sour.replace(index, length, QDate::currentDate().toString("dd.MM.yyyy"));
					index = sour.indexOf(pattern, index + Destination.size());
				}
			}
			else
				if (pattern == "<-time>")
				{
					index = sour.indexOf(pattern);
					while (index >= 0)
					{
						int length = pattern.size();
						sour.replace(index, length, QTime::currentTime().toString("hh_mm_ss"));
						index = sour.indexOf(pattern, index + Destination.size());
					}
				}
	}
	return sour;
}

void ThreadCopy::run()
{
	stopped = false;

	QTime t;
	t.start(); //      

	mutex.lock();
	emit setTaskStatus(IndexThread, "",false,false);
	emit setTaskStatus(IndexThread, " "+NameTask+"    "+QDateTime::currentDateTime().toString("dd.MM.yyyy hh:mm:ss"),false,true);
	mutex.unlock();
	wait();

	foreach (QString bedDir, Source)
	{ 			 
		if (bedDir.indexOf(Destination)==0)
		{
			if (bedDir.size() == Destination.size() || QDir::toNativeSeparators(bedDir).at(Destination.size()) == '\\')
			{
				mutex.lock();
				emit setTaskStatus(IndexThread, " "+NameTask+".   "+Destination+"    "+bedDir,true,false);
				mutex.unlock();
				wait();
				return;
			}
		}
	}

	if (create_additional_dir)
	{
		if (additional_dir_name.isEmpty())
			Destination = Destination + QDir::separator() + QDateTime::currentDateTime().toString("dd.MM.yyyy");
		else
			Destination = Destination + QDir::separator() + QDateTime::currentDateTime().toString(additional_dir_name);
	}

	if (cleardest)
	{
		if (viewMessages)
		{
			mutex.lock();
			emit WriteLnConsole(NameTask + " : " + Destination); 
			mutex.unlock();
			wait();
		}
		if (ext_log)
		{
			mutex.lock();
			emit setTaskStatus(IndexThread, "  " + Destination, false,true);
			mutex.unlock();
			wait();
		}

		cleardir(Destination);
	}

	if (do_before && !execute_before.isEmpty())
	{	
		qint64 pid = 0;
		if (execute_before_dir.isEmpty())
		{
			QFileInfo fi(execute_before);
			execute_before_dir = fi.absolutePath();
		}
		else
			execute_before_dir = replace_text(execute_before_dir);

		    execute_before_cmd = replace_text(execute_before_cmd);
			if (ext_log)
			{
				mutex.lock();
				emit setTaskStatus(IndexThread, "   " + execute_before + ".   : "+execute_before_cmd+",  "+execute_before_dir, false,true);
				mutex.unlock();
				wait();				
			}
		if (!QProcess::startDetached(execute_before, execute_before_cmd.split(" "), execute_before_dir, &pid))
		{
			 mutex.lock(); 
			 emit setTaskStatus(IndexThread, " "+NameTask+".      "+ execute_before,true,false);
			 mutex.unlock();
			 wait();
		}
		else
			if (stream_waiting)
			{		
			HANDLE hwnd = OpenProcess(MAXIMUM_ALLOWED, 0, pid);
			{
				if (!hwnd)
				{
					mutex.lock();
					emit setTaskStatus(IndexThread, " "+NameTask+".      "+ execute_after,true,false);
					mutex.unlock();
					wait();
					return;
				}
			}
			WaitForSingleObject(hwnd, INFINITE); 
			CloseHandle(hwnd);
			}
	}

	GetAllFilesSize();

	foreach (QString sourcedata, Source)
  { 

	  if (QFileInfo(sourcedata).isFile())
		  copyFile_Bl(sourcedata,Destination);	  
	  else	      
		  copydir(sourcedata,Destination+QDir::separator()+QDir(sourcedata).dirName());		  
  }

	Destination = Start_Dest; //      ,    ??
			 
	if (do_after && !execute_after.isEmpty())
	{
		qint64 pid = 0;
		if (execute_after_dir.isEmpty())
		{
			QFileInfo fi(execute_after);
			execute_after_dir = fi.absolutePath();
		}
		else
			execute_after_dir = replace_text(execute_after_dir);

		    execute_after_cmd = replace_text(execute_after_cmd);
			if (ext_log)
			{
				mutex.lock();
				emit setTaskStatus(IndexThread, "   " + execute_after + ".   : "+execute_after_cmd+",  "+execute_after_dir, false,true);
				mutex.unlock();
				wait();
			}

		    if (!QProcess::startDetached(execute_after, execute_after_cmd.split(" "), execute_after_dir,&pid))
			{
			 mutex.lock();
			 emit setTaskStatus(IndexThread, " "+NameTask+".      "+ execute_after,true,false);
			 mutex.unlock();
			 wait();
			}
			else
			   if (stream_waiting)
			{
			HANDLE hwnd = OpenProcess(MAXIMUM_ALLOWED, 0, pid);
			{
			if (!hwnd)
				{
					  mutex.lock();
					  emit setTaskStatus(IndexThread, " "+NameTask+".      "+ execute_after,true,false);
			          return;
					  mutex.unlock();
					  wait();
				}
			}
			WaitForSingleObject(hwnd, INFINITE); 
			CloseHandle(hwnd);
			}

	}
	
     int hours,minutes,seconds;
     int msecunds = t.elapsed();	

     //Days = seconds / 86400;
	 seconds = (msecunds / 1000); 
	 hours = seconds / 3600;
	 minutes  = (seconds % 3600) / 60;
	 seconds %= 60;
	 
	 mutex.lock();
	 emit setTaskStatus(IndexThread, " "+NameTask+".  : "+QString::number(hours)+" ., "+QString::number(minutes)+" ., "+QString::number(seconds)+" . " + ": " + QDateTime::currentDateTime().toString("dd.MM.yyyy hh:mm:ss"), false,false);
	 mutex.unlock();
	 wait();
}

void ThreadCopy::dostart()
{
 if (!isRunning()) 
		start();
}

void ThreadCopy::stop()
{
	mutex.lock();
	emit setTaskStatus(IndexThread, " "+NameTask+"  ",false,true);
	stopped = true;
	mutex.unlock();
	wait();
}

qint64 ThreadCopy::getindex()
{
	return IndexThread;
}