#ifndef SCRIPTWRAPPER_H
#define SCRIPTWRAPPER_H

#include <QtGui/QMainWindow>
#include <QTextEdit>
#include <QTime>
#include <QDesktopWidget>
#include <QLabel>
#include <QDir>
#include <QProcess>
#include <QDesktopServices>

#ifdef Q_OS_WIN
#include <qt_windows.h>
#include <Aclapi.h>
#endif 


class ScriptWrapper : public QObject

{
	Q_OBJECT

public:
	ScriptWrapper();
	~ScriptWrapper();
	void setstart();
	
protected:
	bool deleteFile_(const QString &filename);
	void clearDir_(const QString &, QString Filters, QString Age, QString *err);
	void copyDir_(const QString &, const QString &, QStringList Filters, QString *err);
	QString fixRelativeUncPath(const QString &path);
	QString getlasterror();
	static  const int BUFFSIZE = 64*1024; //   ?????
	char buff[BUFFSIZE];

private:
	volatile bool stopped;
	QStringList dir_entryList_files(const QString &);
	QStringList dir_entryList_dirs(const QString &);
	
signals:
	void WriteLnConsole(const QString &);
	void WriteConsole(const QString &);
	void showMyMessage(const QString &);
	void clearMyConsole();

public slots:
		void writeLn(const QString &);
		void write(const QString &);
		void clearConsole();
		void showMessage(const QString & );
		QDateTime getFileDateTime(const QString &);
		bool writeToFile(const QString &, const QString &);
		QString copyFile(const QString &source, QString target);
		QString copyDir(QString, QString, QString Filters);
	    QString clearDir(QString, QString Filters, QString Age);
		QString deleteFile(const QString &fileName);
		QString executeFile(const QString &filename, const QString &app_arg, QString app_dir, const bool &wait);
		QString runFile(const QString &filename, const QString &app_arg, QString app_dir, const bool &wait);
		QString getLocation(const QString &);
        qint64 GetDiskFreeSp(const QString &Disk);
		qint64 GetDirSize(const QString &dir);
		void quit();
		void pause(const int &);
};


#endif