#ifndef ADD_TASK_H
#define ADD_TASK_H

#include "ui_add_task.h"
#include <QtGui/QMainWindow>

#include <QFileDialog>
#include <QMessageBox>
#include <QMenu>
#include <QCalendarWidget>
#include <QInputDialog>
#include <QStandardItemModel>
#include <QtScript>
#include <QScriptEngineDebugger>
#include "ScriptWrapper.h"
#include <QPainter>

#include <QTextLayout>
#include <QTextBlock>
#include <QScrollBar>
#include <QTextEdit>
#include <QSyntaxHighlighter>

using namespace Ui;

class Editor : public QTextEdit
{
	Q_OBJECT
public:
	Editor(QWidget *parent=0);
	~Editor();
	QStringList keywordPatterns;

protected:
	void paintEvent( QPaintEvent *);
	bool event(QEvent *event); 

	private slots:
		void curposition();

}; 

class Highlighter : public QSyntaxHighlighter
{
	Q_OBJECT

public:
	Highlighter(QTextDocument *parent = 0);

protected:
	void highlightBlock(const QString &text);
};


class add_my_task : public QDialog, public add_task
{
	Q_OBJECT

public:
	add_my_task(QWidget *parent = 0);
	~add_my_task();
	qint64 itemindex;
	bool edit, disable_write;
	QString lastOpenDir;
	void form_clear();
	QValidator *v;
	Editor *scriptEdior;
	QScriptEngine *engine;
	ScriptWrapper *my_ScriptWrapper;
	void set_current_plan_items(const qint64 &);
	void get_top_item_state();

	private slots:
		void on_nextButton_clicked();
		void on_cancelButton_1_clicked();
		void on_cancelButton_2_clicked();
		void on_cancelButton_3_clicked();
		void on_cancelButton_4_clicked();
		void on_cancelButton_5_clicked();
		void on_backButton_1_clicked();
		void on_backButton_2_clicked();

		void on_add_Button_clicked();
		void on_dest_Button_clicked();
		void on_delete_Button_clicked();
		void on_save_Button_clicked();
		void on_save_Button_2_clicked();
		void on_save_Button_3_clicked();
		void on_save_Button_4_clicked();
		void on_add_ext_clicked();
		void on_add_file_clicked();
		void on_add_dir_clicked();
		void on_delete_from_list_clicked();
		void on_notRewrite_stateChanged(int);
		void on_reWrite_stateChanged(int);
		void set_item_filter_state();
		void set_CheckBox_state(int);
		void on_listWidget_itemDoubleClicked(QListWidgetItem *) ;
		void on_list_files_and_dirs_itemDoubleClicked(QListWidgetItem *) ;
		void on_include_filter_stateChanged(int);
		void on_exclude_filter_stateChanged(int);
		void on_plan_items_currentItemChanged(QListWidgetItem * current, QListWidgetItem * previous);
		void on_plan_items_customContextMenuRequested(QPoint);
		void on_enable_scheduler_stateChanged(int state);
		void on_comboBox_currentIndexChanged(int);
		void on_comboBox_2_currentIndexChanged(int);
		void on_conditionCombo_currentIndexChanged(int);
		void set_state(bool);
		void on_execute_before_customContextMenuRequested(QPoint);
		void on_execute_after_customContextMenuRequested(QPoint);
		void select_before();
		void select_after();
		void replace_all_param();

		void add_files();
		void add_dirs();
		void load_script();
		void debug_script();
		void save_script();
		void create_new_script_file();
		void rewrite_exists_script_file();

protected:
	QCalendarWidget *popupcal;
	void update_interfase_scheduler(const qint64 &);
	void closeEvent ( QCloseEvent * event ); 

signals:
	void add_and_update(const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, const QString &name_add_dir, 
		const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, const int &condition, 
		const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, const int &condition_2, 
		const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, const QString &execute_before_cmd, 
		const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, const QString &execute_after_dir, 
		const int &cmp_md5, const bool &noRecursive, const int &index);		

	void edit_and_update(const qint64 &my_index, const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, 
		const QString &name_add_dir, const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, 
		const int &condition, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, 
		const int &condition_2, const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, 
		const QString &execute_before_cmd, const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, 
		const QString &execute_after_dir, const int &cmp_md5, const bool &noRecursive, const int &index);

		void edit_script(const qint64 &, const QString &, const QString &, const int &);
		void add_script(const QString &, const QString &, const int &);

		void update_fase();
		void query_disable_write();

		void setup_scheduler(const qint64 &index, const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
			const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
			const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time);

		void replace_all_param(const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
			const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
			const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time);

		void save_setup(const int &autostart_planner, const int &concurrent_execution, const int &ext_log, const int &viewMessages, const int &currentIndex, 
			const int &Monday_1, const int &Tuesday_1, const int &Wednesday_1, const int &Thursday_1, const int &Friday_1, const int &Saturday_1, const int &Sunday_1, 
			const int & month_1_1, const int &month_1_2, const int &month_1_3, const int &month_1_4, const int &month_1_5, const int &month_1_6, const int &month_1_7, const int &month_1_8, const int &month_1_9, 
			const int &month_1_10, const int &month_1_11, const int &month_1_12, const int &repeat_min_2, const QString &dateEdit_2, const QString &timeEdit_2, const int &clear_log, const int &stream_waiting, 
			const int &copy_empty_dir, const int &do_limited_threds, const int &count_limited_threads, const int &do_add_dir, const int &doHide);
};



#endif

