#include "get_status.h"

get_my_status::get_my_status(QWidget *parent): QDialog(parent)
{
	setupUi(this);
	myindex = 0;

	mydatapath = QDesktopServices::storageLocation(QDesktopServices::DataLocation)+"/exCopy";
	QByteArray mystate;
	QByteArray mygeom;
	uchar geo_size;

	QFile file(mydatapath+"//size_err.dat");

	if (file.open(QFile::ReadOnly)) 
	{
		bool ok = file.getChar((char*)&geo_size);
		if (ok) 
		{
			mygeom=file.read(geo_size);
			mystate=file.readAll();
			file.close();
			restoreGeometry(mygeom);
		}	
	}	
}

get_my_status::~get_my_status()
{

}

void get_my_status::viewlog()
{
	emit viewLog(myindex);
}

void get_my_status::showEvent(QShowEvent *event)
{	
	viewlog();
	QDialog::showEvent(event);
}

void get_my_status::closeEvent( QCloseEvent * event )
{
	QByteArray mygeom = saveGeometry();
	QFile file(mydatapath+"//size_err.dat");

	if (file.open(QFile::WriteOnly)) 
	{	
		file.putChar((uchar)mygeom.size());
		file.write(mygeom);
		file.close();
	}
	
	event->accept();	
}

void get_my_status::clsErr()
{
 emit doClsErr(myindex);
 messageList->clear();
}

void get_my_status::update()
{
	emit viewLog(myindex);
}

void get_my_status::on_messageList_customContextMenuRequested(QPoint)
{
	QMenu menu;
	menu.addAction(tr("  "),this , SLOT(clsErr()));
	menu.addAction(tr(" "),this , SLOT(update()));
	menu.exec(QCursor::pos());	
}

