#include "new_scheduller.h"

QString mydatapath="";
get_my_status *getstatus;

QSystemTrayIcon *trayIcon;
QMenu *trayIconMenu;

my_stiker::my_stiker(QWidget *parent)
{
	setWindowFlags(Qt::Tool | Qt::WindowStaysOnTopHint | Qt::MSWindowsFixedSizeDialogHint);
	setWindowTitle("");
	setAttribute(Qt::WA_DeleteOnClose,true);
	msg = new QTextEdit(this);
	//msg->setFocusPolicy(Qt::NoFocus);
	int x_=300,y_=300;
	resize(x_,y_);
	msg->resize(x_*0.8,y_*0.8);
	msg->move((x_/2)-(msg->width()/2),(y_/2)-(msg->height()/2));
}

my_stiker::~my_stiker()
{
	if (msg)
	{
		delete msg;
		msg = 0;
	}
}

void new_scheduller::copy_data_files(const QString &source_path, const QString &dest_path)
{
	QDir dir (source_path);
	QString dest_dir(dest_path);

	foreach (QString file, dir.entryList(QStringList ("*.*"), QDir::Files))
	{		
		QDir().mkpath(dest_dir);

		if (QFile::exists(dest_dir+"/"+file))
			QFile::remove(dest_dir+"/"+file);

		if (!QFile().copy(dir.absolutePath()+"/"+file,dest_dir+"/"+file))
			QMessageBox::warning(this, "!", "  "+ file,dest_dir+"/"+file);

	}

	foreach (QString subDir, dir.entryList(QDir::Dirs | QDir::NoDotAndDotDot))
		copy_data_files(source_path+QDir::separator()+subDir,dest_path+QDir::separator()+subDir);
}

new_scheduller::new_scheduller(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);
	QApplication::setStyle(new  QCleanlooksStyle);

	/*QFile filest("./mystyle.qss");
	filest.open(QFile::ReadOnly);
	QString st = QLatin1String(filest.readAll());
	qApp->setStyleSheet(st);*/

	QAction *restoreAction = new QAction(QIcon(":/icons/win.png"), tr(""), this);
	connect(restoreAction, SIGNAL(triggered()), this, SLOT(restoremywindow()));

	QAction *restoreActionfull = new QAction(QIcon(":/icons/fullscreen.png"), tr("   "), this);
	connect(restoreActionfull, SIGNAL(triggered()), this, SLOT(restoremywindowfull()));

	QAction *eraseDatAction = new QAction(QIcon(":/icons/default.png"), tr("    "), this);
	connect(eraseDatAction, SIGNAL(triggered()), this, SLOT(eraseDat()));

	QAction  *helpAction = new QAction(QIcon(":/icons/pro.png"), tr(" "), this);
	connect(helpAction,  SIGNAL(triggered()), this, SLOT(help()));

	QAction  *quitAction = new QAction(QIcon(":/icons/exit.png"), tr(""), this);
	connect(quitAction,  SIGNAL(triggered()), this, SLOT(close_app()));
		
	trayIconMenu = new QMenu;	
	trayIconMenu->addAction(restoreAction);
	trayIconMenu->addAction(restoreActionfull);
	trayIconMenu->addSeparator();
	trayIconMenu->addAction(eraseDatAction);
	trayIconMenu->addSeparator();
	trayIconMenu->addAction(helpAction);
	trayIconMenu->addAction(quitAction);
	trayIcon = new QSystemTrayIcon(QIcon(":/icons/main.png"));
	connect(trayIcon, SIGNAL(activated(QSystemTrayIcon::ActivationReason)), this, SLOT(iconActivated(QSystemTrayIcon::ActivationReason)));
	trayIcon->setContextMenu(trayIconMenu);	
	trayIcon->setToolTip(" ");
	trayIcon->show();

	connect(this, SIGNAL(dohidemywindow()),this, SLOT(hidemywindow()), Qt::QueuedConnection);
	connect(this, SIGNAL(dorestoremywindow()),this, SLOT(restoremywindow()), Qt::QueuedConnection);
	connect(this, SIGNAL(dorestoremywindowfull()),this, SLOT(restoremywindowfull()), Qt::QueuedConnection);

	connect(ui.tableWidget->horizontalHeader(), SIGNAL(sectionResized(int, int, int)), this, SLOT(resize_header(int, int, int)));
	
	setMouseTracking(true);

	mydatapath = QDesktopServices::storageLocation(QDesktopServices::DataLocation)+"/exCopy";
	qApp->addLibraryPath(mydatapath + "/plugins/");

	if (!QFile::exists(mydatapath+"/setup.ini") || !QFile::exists(mydatapath + "/plugins/imageformats/qgif4.dll") || !QFile::exists(mydatapath+"/gbak.exe") || !QFile::exists(mydatapath+"/gfix.exe"))
	{

		copy_data_files("./app_data", mydatapath);
		QMessageBox::warning(this, "!", "  "+mydatapath+
			"      .     .      !");
	}
	
	QByteArray mystate;
	QByteArray mygeom;
	uchar geo_size;

	QFile file(mydatapath+"/size.dat");

	    if (file.open(QFile::ReadOnly))
	{
		bool ok = file.getChar((char*)&geo_size);
		if (ok) 
		{
			mygeom=file.read(geo_size);
			mystate=file.readAll();
			file.close();
			restoreGeometry(mygeom);
			restoreState(mystate);
		}
	}
		else
		{
			ui.dockWidgetContents_2->setMaximumHeight(170);
			//resize(qApp->desktop()->availableGeometry(this).width(), qApp->desktop()->availableGeometry(this).height());
			move(qApp->desktop()->availableGeometry(this).center()-this->rect().center());
		}
			
	add_tsk = new add_my_task(this);
	getstatus = new get_my_status(this);
	
	connect(getstatus, SIGNAL(doClsErr(const qint64 &)), this, SLOT(cleaErrs(const qint64 &)));
	connect(getstatus, SIGNAL(viewLog(const qint64 &)), this, SLOT(viewLog(const qint64 &)));

	connect(add_tsk, SIGNAL(add_and_update(const QString &, const QStringList &, const QString &, const int &, const QString &, const int &, const int &, const int &, 
		const int &, const QString &, const int &, const QStandardItemModel &, const QStandardItemModel &, const QStandardItemModel &, const int &, const int &, 
		const QString &, const int &, const int &, const QString &, const QString &, const QString &, const int &, const QString &, const QString &, const QString &, 
		const int &, const bool &, const int &)), this, 
		SLOT(add_data(const QString &, const QStringList &, const QString &, const int &, const QString &, const int &, const int &, const int &, 
		const int &, const QString &, const int &, const QStandardItemModel &, const QStandardItemModel &, const QStandardItemModel &, const int &, const int &, 
		const QString &, const int &, const int &, const QString &, const QString &, const QString &, const int &, const QString &, const QString &, const QString &, 
		const int &, const bool &, const int &)));

	connect(add_tsk, SIGNAL(edit_and_update(const qint64 &, const QString &, const QStringList &, const QString &, const int &, const QString &, 
		const int &, const int &, const int &, const int &, const QString &, const int &, const QStandardItemModel &, const QStandardItemModel &, 
		const QStandardItemModel &, const int &, const int &, const QString &, const int &, const int &, const QString &, const QString &, const QString &, 
		const int &, const QString &, const QString &, const QString &, const int &, const bool &, const int &)), this, 
		SLOT(edit_data(const qint64 &, const QString &, const QStringList &, const QString &, const int &, const QString &, 
		const int &, const int &, const int &, const int &, const QString &, const int &, const QStandardItemModel &, const QStandardItemModel &, 
		const QStandardItemModel &, const int &, const int &, const QString &, const int &, const int &, const QString &, const QString &, const QString &, 
		const int &, const QString &, const QString &, const QString &, const int &, const bool &, const int &)));

	connect(add_tsk, SIGNAL(edit_script(const qint64 &, const QString &, const QString &, const int &)), this, SLOT(edit_script(const qint64 &, const QString &, const QString &, const int &)));
	connect(add_tsk, SIGNAL(add_script(const QString &, const QString &, const int &)), this, SLOT(add_script(const QString &, const QString &, const int &)));
	connect(add_tsk, SIGNAL(setup_scheduler(const qint64 &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
		const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &)), this, SLOT(setup_scheduler(const qint64 &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
		const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &)));

	connect(add_tsk, SIGNAL(replace_all_param(const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
		const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &)), this, SLOT(replace_all_param(const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
		const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &)));

	connect(add_tsk, SIGNAL(save_setup(const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
        const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &, const int &, const int &, const int &, const int &, const int &, const int &, const int &)), this, 
		SLOT(save_setup(const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, 
		const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const int &, const QString &, const QString &, const int &, const int &, const int &, const int &, const int &, const int &, const int &)));
	connect(add_tsk, SIGNAL(update_fase()), this, SLOT(update_fase()));
	connect(add_tsk, SIGNAL(query_disable_write()), this, SLOT(disable_write()));
	

	connect(add_tsk->my_ScriptWrapper, SIGNAL(clearMyConsole()), this, SLOT(clearMyConsole()));
	connect(add_tsk->my_ScriptWrapper, SIGNAL(WriteLnConsole(const QString &)), this, SLOT(WriteLnConsole(const QString &)));
	connect(add_tsk->my_ScriptWrapper, SIGNAL(WriteConsole(const QString &)), this, SLOT(WriteConsole(const QString &)));
	connect(add_tsk->my_ScriptWrapper, SIGNAL(showMyMessage(const QString &)), this, SLOT(showMyMessage(const QString &)));
	connect(this, SIGNAL(stopScriptWrapper()), add_tsk->my_ScriptWrapper, SLOT(quit()));
	
	start_now = false;
	delete_Options = false;
	size_horizontalHeader_1 = 0;
	size_horizontalHeader_2 = 0;
	
	settings = new QSettings(mydatapath + "/setup.ini",QSettings::IniFormat,this);
	settings->setIniCodec("CP1251");

	if (settings->childGroups().count()==0)	
		QMessageBox::information(0, " !", "  "+mydatapath + "/setup.ini"+"    .");
			
	settings->beginGroup("Main");
	db = QSqlDatabase::addDatabase("QIBASE");
	db.setHostName(settings->value("HOST").toString());
	db.setDatabaseName(settings->value("DatabaseName").toString());
	db.setUserName(settings->value("UserName").toString());
	db.setPassword(settings->value("Password").toString());
	QString my_setting="exCopy (1.0) ";
	my_setting.append(": "+db.hostName()+", : "+db.databaseName());
	setWindowTitle(my_setting);
	settings->endGroup();

	ui.tableWidget->setItemDelegateForColumn(2, new ButtonDelegate (ui.tableWidget));
	ui.tableWidget->setItemDelegateForColumn(3, new ProgressBarDelegate (ui.tableWidget));

	if(!db.open())
	{
		QSqlError er = db.lastError();
		QMessageBox::information(0, er.driverText(),er.databaseText());
	}
	else
	{
		settings->beginGroup("Headers");
		size_horizontalHeader_1 = settings->value("1",0).toInt();
		size_horizontalHeader_2 = settings->value("2",0).toInt();
		settings->endGroup();		
		update_table();
	}

	if (ui.tableWidget->rowCount() != 0)
		ui.tableWidget->setCurrentCell(0,1);

	set_last_run_time(-1); //      
	set_last_run_time_ini(); //   ini 

	get_setup();
	
	QAction *addtsk_ = new QAction(QIcon(":/icons/new.png"), tr(" "), this);
	ui.toolBar->addAction(addtsk_);
	addtsk_->setObjectName("add_action");
	connect(addtsk_,  SIGNAL(triggered()), this, SLOT(addtsk()));

	QAction *copytsk_ = new QAction(QIcon(":/icons/copy.png"), tr(" "), this);
	copytsk_->setObjectName("copy_action");
	ui.toolBar->addAction(copytsk_);
	connect(copytsk_,  SIGNAL(triggered()), this, SLOT(copytsk_menu()));

	QAction *edittsk_ = new QAction(QIcon(":/icons/edit.png"), tr(" "), this);
	edittsk_->setObjectName("edit_action");
	ui.toolBar->addAction(edittsk_);
	connect(edittsk_,  SIGNAL(triggered()), this, SLOT(edittsk()));

	QAction *deltsk_ = new QAction(QIcon(":/icons/del.png"), tr(" "), this);
	deltsk_->setObjectName("del_action");
	ui.toolBar->addAction(deltsk_);
	connect(deltsk_,  SIGNAL(triggered()), this, SLOT(deltsk()));

	ui.toolBar->addSeparator();

	QAction *plantsk_ = new QAction(QIcon(":/icons/plan.png"), tr("  "), this);
	plantsk_->setObjectName("plan_action");
	ui.toolBar->addAction(plantsk_);
	connect(plantsk_,  SIGNAL(triggered()), this, SLOT(plantsk()));

	QAction *pause_ = new QAction(tr("/    "), this);
	if (autostart_planner)
			pause_->setIcon(QIcon(":/icons/pause.png"));
	
	else
		pause_->setIcon(QIcon(":/icons/play.png"));
		
	ui.toolBar->addAction(pause_);
	pause_->setObjectName("pause_action");
	connect(pause_,  SIGNAL(triggered()), this, SLOT(stop_start()));

	QAction *startnow_ = new QAction(QIcon(":/icons/play_one.png"), tr("/  "), this);
	ui.toolBar->addAction(startnow_);
	startnow_->setObjectName("startnow_action");
	connect(startnow_,  SIGNAL(triggered()), this, SLOT(startnow()));

	ui.toolBar->addSeparator();

	QAction *clear_ = new QAction(QIcon(":/icons/clear.png"), tr("    "), this);
	ui.toolBar->addAction(clear_);
	clear_->setObjectName("clear_action");
	connect(clear_,  SIGNAL(triggered()), this, SLOT(clear()));

	ui.toolBar->addSeparator();

	QAction *backup_ = new QAction(QIcon(":/icons/backup.png"), tr("   "), this);
	ui.toolBar->addAction(backup_);
	backup_->setObjectName("backup_action");
	connect(backup_,  SIGNAL(triggered()), this, SLOT(backup()));

	QAction *restore_ = new QAction(QIcon(":/icons/restore.png"), tr("    "), this);
	ui.toolBar->addAction(restore_);
	restore_->setObjectName("restore_action");
	connect(restore_,  SIGNAL(triggered()), this, SLOT(restore()));

	QAction *export_ = new QAction(QIcon(":/icons/export.png"), tr("    XML "), this);
	ui.toolBar->addAction(export_);
	export_->setObjectName("export_action");
	connect(export_,  SIGNAL(triggered()), this, SLOT(save_to_file()));

	QAction *import_ = new QAction(QIcon(":/icons/import.png"), tr("   XML "), this);
	ui.toolBar->addAction(import_);
	import_->setObjectName("import_action");
	connect(import_,  SIGNAL(triggered()), this, SLOT(restore_from_file()));

	ui.toolBar->addSeparator();

	QAction *setup_ = new QAction(QIcon(":/icons/setup.png"), tr(""), this);
	ui.toolBar->addAction(setup_);
	setup_->setObjectName("setup_action");
	connect(setup_,  SIGNAL(triggered()), this, SLOT(setup()));

	tT.setSingleShot(true);

	tsktimer = new QTimer;
	connect (tsktimer, SIGNAL (timeout ()), this, SLOT (do_all_tsks()));

	update_timer = new QTimer;
	connect (update_timer, SIGNAL (timeout ()), this, SLOT (update_interface()));

	if (autostart_planner)
	tsktimer->start(5000); //5 .

	update_timer->start(700);//  
}

void new_scheduller::resize_header(int logicalIndex, int oldSize, int newSize)
{
	if (logicalIndex == 1)
	    size_horizontalHeader_1 = newSize;
	else
	if (logicalIndex == 2)
		size_horizontalHeader_2 = newSize;
}

void new_scheduller::help()
{
	QMessageBox::about(this, tr(" "),
		tr("exCopy (1.0) : <a href=\"alexe-titov@yandex.ru\">alexe-titov@yandex.ru</a>\n"
		"<p> : <a href=\"http://alexe-titov.narod.ru/excopy\">http://alexe-titov.narod.ru/excopy</a></p>"));
}

void new_scheduller::close_app()
{
	//QMessageBox::StandardButton ret;
	//ret=QMessageBox::question(this, "","      ?", QMessageBox::Ok | QMessageBox::Cancel);
	//if (ret==QMessageBox::Ok)
 //{
	doAllStop();
	qApp->quit();	
 //}
}

void new_scheduller::iconActivated(QSystemTrayIcon::ActivationReason reason)
{
	trayIconMenu->exec(QCursor::pos());				
}

void new_scheduller::eraseDat()
{	
	settings->beginGroup("Headers");
	settings->setValue("1", 0);
	settings->setValue("2", 0);
	settings->endGroup();
	settings->sync();	
	
	QFile file(mydatapath+"/size.dat");
	QFile file_(mydatapath+"/size_err.dat");
	
	file.remove();
	file_.remove();
	QMessageBox::information(this, "", "   .  .");
	delete_Options = true;
}

new_scheduller::~new_scheduller()
{
	if (add_tsk)
	{
		delete add_tsk;
		add_tsk = 0;
	}

	if (settings)
	{
		delete settings;
		settings = 0;
	}

	if (getstatus)
	{
		delete getstatus;
		getstatus = 0;
	}

	if (tsktimer)
	{
		delete tsktimer;
		tsktimer = 0;
	}

	if (update_timer)
	{
		delete update_timer;
		update_timer = 0;
	}

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())
		{
			PointerThreadsCopy[i]->stop();
		    QSplashScreen splash(QPixmap(":/icons/loader.png"));
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
		    splash.show();
		    splash.showMessage(" ...", Qt::AlignBottom);
		    PointerThreadsCopy[i]->wait();
		}
	}
	for (int j = 0; j < PointerThreadsScript.count(); j++)
	{				   
		if (PointerThreadsScript[j]->isRunning())
		{
			PointerThreadsScript[j]->stop();
			QSplashScreen splash(QPixmap(":/icons/loader.png"));
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ...", Qt::AlignBottom);
			PointerThreadsScript[j]->wait();		   
		}
	}

	qDeleteAll(PointerThreadsCopy.begin(), PointerThreadsCopy.end());
	PointerThreadsCopy.clear();

	if (db.isOpen())
		db.close();

	if (trayIconMenu)
	{
		delete trayIconMenu;
		trayIconMenu = 0;
	}

	if (trayIcon)
	{
		delete trayIcon;
		trayIcon = 0;
	}
}

void new_scheduller::showMyMessage(const QString &message)
{
	my_stiker *stiker=new my_stiker;
	stiker->msg->setText(message);
	QDesktopWidget desktop;
	QRect space = desktop.availableGeometry();
	qsrand(QTime::currentTime().msecsTo(QTime()));
	int newx=qrand()%(space.width()-stiker->width());
	int newy=qrand()%(space.height()-stiker->height());
	stiker->move(newx,newy);	
	stiker->msg->setText(message);
	stiker->show();
}

void new_scheduller::on_tableWidget_cellClicked( int row, int column )
{
	if (column == 2)
	{
	ui.tableWidget->editItem(ui.tableWidget->item(row,column));
	}
}

void new_scheduller::on_tableWidget_currentItemChanged( QTableWidgetItem * current, QTableWidgetItem * previous )
{
	if (current) //   ,        
	{	
		if (add_tsk->isVisible() && add_tsk->edit )
			edittsk();
		else
			if (getstatus->isVisible())
			{
				getstatus->myindex = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
	            getstatus->viewlog();
			}
	}
}

QString new_scheduller::GetFieldType(const QString &Table, const QString &Field)
{
	QSqlQuery myquery;  
	myquery.prepare("SELECT * FROM GET_FIELD_TYPE(?,?)");	  
	myquery.bindValue(0, Table);
	myquery.bindValue(1, Field);
	if (!myquery.exec())
		return "";
	myquery.first();
	return myquery.value(1).toString().trimmed();		
}

void new_scheduller::reconnect_bd()
{
	QSqlQuery myquery;
	if (myquery.exec("SELECT TASKS.ID AS FIELD_1 FROM TASKS"))
	return;
	else
	{
		if (db.isOpen())
		{
			db.close();
		}

		QSqlDatabase::removeDatabase(db.connectionName());		
		Sleep(100);

		settings->beginGroup("Main");
		db = QSqlDatabase::addDatabase("QIBASE");
		db.setHostName(settings->value("HOST").toString());
		db.setDatabaseName(settings->value("DatabaseName").toString());
		db.setUserName(settings->value("UserName").toString());
		db.setPassword(settings->value("Password").toString());
		QString my_setting=" . ";
		my_setting.append(": "+db.hostName()+", : "+db.databaseName());
		setWindowTitle(my_setting);
		settings->endGroup();

		Sleep(100);

		if(!db.open())
		{
			QSqlError er = db.lastError();
			WriteLnConsole(er.driverText()+" "+er.databaseText()); 
		}
		else
			update_table();

		QSqlQuery myquery_;
		if (myquery_.exec("SELECT TASKS.ID AS FIELD_1 FROM TASKS"))
			WriteLnConsole("     "+ QDateTime::currentDateTime().toString("dd.MM.yyyy HH.mm.ss")); 
	}
}

void new_scheduller::update_table()
{	
	QSqlQuery myquery;
	myquery.clear();

	if (myquery.exec("SELECT COUNT(TASKS.ID) AS FIELD_1 FROM TASKS"))
	{
		myquery.first();
		int count=myquery.value(0).toInt();
		if (myquery.exec("select ID,NAME,STATUS,PERCENT, MYINDEX, ENABLE_SCHEDULER from TASKS"))
		{
			ui.tableWidget->setUpdatesEnabled(false);
			int row=0,column=0;
			ui.tableWidget->setColumnCount(myquery.record().count()); // 
			ui.tableWidget->setRowCount(count); //
			QStringList mycolumns;
			mycolumns<<""<<" "<<""<<" "<<"TYPE"<<"en";
			ui.tableWidget->setHorizontalHeaderLabels(mycolumns);
			while ( myquery.next() )
			{
				for (column=0;column<ui.tableWidget->columnCount();column++)
				{
					QString name = myquery.value(column).toString().trimmed();
					QString fieldtype=GetFieldType("TASKS",myquery.record().fieldName(column));
					if (fieldtype=="INT64" || fieldtype=="SHORT")
					{
						QTableWidgetItem *newItem = new QTableWidgetItem();
						newItem->setData(0,myquery.value(column).toLongLong());
						ui.tableWidget->setItem(row, column, newItem);
							/*if (column==2)
								ui.tableWidget->openPersistentEditor(newItem);*/
					}
					else
					{
						QTableWidgetItem *newItem = new QTableWidgetItem(name);
						ui.tableWidget->setItem(row, column, newItem);
						/*if (column==2)
							ui.tableWidget->openPersistentEditor(newItem);*/
					}						
				}
				if (myquery.value(5).toInt() == 0)			
					ui.tableWidget->item(row,1)->setTextColor(Qt::lightGray);				
				row++;				
			}

			ui.tableWidget->hideColumn(0);
			ui.tableWidget->hideColumn(4);
			ui.tableWidget->hideColumn(5);
		
			if (size_horizontalHeader_1 == 0 || size_horizontalHeader_2 == 0)
			{
			   ui.tableWidget->horizontalHeader()->resizeSection(1,mycolumns.at(1).length()*20);
			   ui.tableWidget->horizontalHeader()->resizeSection(2,mycolumns.at(2).length()*28);
			}
			else
			{
				ui.tableWidget->horizontalHeader()->resizeSection(1,size_horizontalHeader_1);
				ui.tableWidget->horizontalHeader()->resizeSection(2,size_horizontalHeader_2);
			}

			//ui.tableWidget->horizontalHeader()->resizeSection(3,mycolumns.at(3).length()*8);
			ui.tableWidget->verticalHeader()->hide();
			ui.tableWidget->clearSelection();
			ui.tableWidget->sortItems(1,Qt::AscendingOrder);
			ui.tableWidget->horizontalHeader()->setHighlightSections(false);
			ui.tableWidget->horizontalHeader()->setStretchLastSection(true);
			ui.tableWidget->resizeRowsToContents();
			ui.tableWidget->setUpdatesEnabled(true);
		}
		else		
			WriteLnConsole("   - : select ID,NAME,STATUS,PERCENT from TASKS.");
	}
	else	
		WriteLnConsole("      - : SELECT COUNT(TASKS.ID) AS FIELD_1 FROM TASKS");
}

void new_scheduller::start_all_tsk()
{		
	if (ui.tableWidget->rowCount() == 0) 
		return;

	bool dostart, found, fulfilled = false;
	QSqlQuery myquery; 
	qint64 my_index=-1, ex_size_copy;
	QStringList source;
	QStandardItemModel ext, files, dirs;
	QString dest,taskname,add_dir_name,ex_Date_Copy, execute_before, execute_before_cmd, execute_before_dir,  execute_after, execute_after_cmd, execute_after_dir;
	int index, notRewrite, create_add_dir, cleardest, reWrite, exDate, condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;
	bool noRecursive = false;

	for (int i = 0;i < ui.tableWidget->model()->rowCount();i++)
 {
		my_index = ui.tableWidget->model()->data(ui.tableWidget->model()->index(i,0)).toLongLong();
		dostart = true;	
		found = false;
		int task_type = get_task_type(my_index);

		if (task_type == 1)
	{

		for (int j=0; j<PointerThreadsCopy.count(); j++)
			{
				if (PointerThreadsCopy[j]->getindex() == my_index)  //       
				{
					dostart = false;
					found = true;
					break;
				}
			}

		if (!found) //          
		  if (!start_tsk(my_index))	//        
			  dostart = false;

		if (!tsktimer->isActive() && !start_now) // ,    			
				dostart = false;
		
			if (dostart)
				{						
					fulfilled = true; //       
					getdata(my_index, &source, &dest, &index, &taskname, &create_add_dir, &add_dir_name, &cleardest, &notRewrite, &reWrite, &exDate, 
					&ex_Date_Copy, &condition, &ext, &files, &dirs, &exSize, &condition_2, &ex_size_copy, &sizecombo, &do_before, &execute_before, 
					&execute_before_cmd, &execute_before_dir, &do_after, &execute_after, &execute_after_cmd, &execute_after_dir, &cmp_md5, &noRecursive);

					myThreadCopy = new ThreadCopy();

					myThreadCopy->setData(taskname, source, dest, my_index, create_add_dir, add_dir_name, cleardest, notRewrite, reWrite, exDate, ex_Date_Copy, 
						condition, ext, files, dirs, exSize, condition_2, ex_size_copy, sizecombo, do_before, execute_before, execute_before_cmd, execute_before_dir, 
						do_after, execute_after, execute_after_cmd, execute_after_dir, cmp_md5, ext_log, viewMessages, clear_log, stream_waiting, 
						copy_empty_dir, do_add_dir, noRecursive);	

					PointerThreadsCopy.append(myThreadCopy);
					connect(myThreadCopy, SIGNAL(setTaskStatus(qint64, const QString &, const bool &)), this, SLOT(writeTaskStatus(const qint64 &, const QString &, const bool &)));
					connect(myThreadCopy, SIGNAL(save_thread_log(qint64, const QStringList &)), this, SLOT(save_thread_log(qint64, const QStringList &)));
					connect(myThreadCopy, SIGNAL(setPercent(qint64, double)), this, SLOT(setProgress (qint64, double)));
					connect(myThreadCopy, SIGNAL(thread_stopped(qint64)), this, SLOT(delete_thread(qint64)));
					connect(myThreadCopy, SIGNAL(WriteLnConsole(const QString &)), this, SLOT(WriteLnConsole(const QString &)));							
					myThreadCopy->dostart();		
					  
					if (do_limited_threds)
							while(PointerThreadsCopy.count() >= count_limited_threads) 
					   {
						   connect(&tT, SIGNAL(timeout()), &q, SLOT(quit()));
						   tT.start(50);
						   q.exec();						
					   }						 				  

			    }
	}
		if (task_type == 2)
		{
			for (int j=0; j<PointerThreadsScript.count(); j++)
			{
				if (PointerThreadsScript[j]->getindex() == my_index)  //       
				{
					dostart = false;
					found = true;
					break;
				}
			}

			if (!found) //          
				if (!start_tsk(my_index))	//        
					dostart = false;

			if (!tsktimer->isActive() && !start_now) // ,    
				dostart = false;

			if (dostart)
			{
				fulfilled = true;
				my_script = new ThreadScript;
				my_script->setData(getscript(my_index), my_index);

				PointerThreadsScript.append(my_script);
				connect(my_script, SIGNAL(setTaskStatus(qint64, const QString &, const bool &)), this, SLOT(writeTaskStatus(qint64, const QString &, const bool &)));
				connect(my_script, SIGNAL(save_thread_log(qint64, const QStringList &)), this, SLOT(save_thread_log(qint64, const QStringList &)));
				connect(my_script, SIGNAL(thread_stopped(qint64)), this, SLOT(delete_thread(qint64)));
				connect(my_script->my_ScriptWrapper, SIGNAL(clearMyConsole()), this, SLOT(clearMyConsole()));
				connect(my_script->my_ScriptWrapper, SIGNAL(WriteLnConsole(const QString &)), this, SLOT(WriteLnConsole(const QString &)));
				connect(my_script->my_ScriptWrapper, SIGNAL(WriteConsole(const QString &)), this, SLOT(WriteConsole(const QString &)));
				connect(my_script->my_ScriptWrapper, SIGNAL(showMyMessage(const QString &)), this, SLOT(showMyMessage(const QString &)));
				connect(this, SIGNAL(stopScriptWrapper()), my_script->my_ScriptWrapper, SLOT(quit()));
				my_script->dostart();	

				if (do_limited_threds)
					while(PointerThreadsCopy.count() >= count_limited_threads) 
					{
						connect(&tT, SIGNAL(timeout()), &q, SLOT(quit()));
						tT.start(50);
						q.exec();						
					}					
			}	
		}
 }
 	if (!concurrent_execution && fulfilled)
	{
		set_last_run_time_ini(); //    ,      ,        
		get_setup();
	}
}
		
void new_scheduller::delete_thread(qint64 index)
{	
	for (int i = 0; i < PointerThreadsCopy.count(); i++)
  {
	if (PointerThreadsCopy[i]->getindex() == index)
		{
			PointerThreadsCopy[i]->deleteLater();
			PointerThreadsCopy.remove(i);
			set_last_run_time(index);
			break;
	    }
  }

	for (int j = 0; j < PointerThreadsScript.count(); j++)
	{
		if (PointerThreadsScript[j]->getindex() == index)
		{
			PointerThreadsScript[j]->deleteLater();
			PointerThreadsScript.remove(j);
			set_last_run_time(index);
			break;
		}
	}
}

void new_scheduller::get_plan_item()
{
	add_tsk->plan_items->setUpdatesEnabled(false);
	add_tsk->plan_items->clear();
	QSqlQuery myquery;
	myquery.prepare("SELECT * FROM GET_PLAN_ITEM");

	if (!myquery.exec())
	{
		QMessageBox::information(this, "","   (  GET_PLAN_ITEM)");
		return;
	}
	else
	{			
		while ( myquery.next() )
		{	
			QListWidgetItem *newItem = new QListWidgetItem;
			newItem->setData(Qt::UserRole, myquery.value(0).toLongLong());
			newItem->setText(myquery.value(1).toString().trimmed());
			add_tsk->plan_items->insertItem(0, newItem);		
		}

		add_tsk->plan_items->sortItems(Qt::AscendingOrder);

		if (add_tsk->plan_items->count() != 0)
			add_tsk->plan_items->setCurrentRow(0);

		add_tsk->plan_items->setUpdatesEnabled(true);

		myquery.clear();
	}
}

qint64 new_scheduller::add_data(const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, 
	const QString &name_add_dir, const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, 
	const int &condition, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, const int &condition_2, 
	const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, const QString &execute_before_cmd, 
	const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, const QString &execute_after_dir, 
	const int &cmp_md5, const bool &noRecursive, const int &index)
{		
	qint64 new_index;
	QSqlQuery query; 
	query.prepare("SELECT * FROM INSERT_NEW_RECORD(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");	  
	query.bindValue(0, taskname);
	query.bindValue(1, sourcefilesnames.join("\n"));
	query.bindValue(2, destdir);
	query.bindValue(3, create_add_dir);
	query.bindValue(4, name_add_dir);
	query.bindValue(5, docleardest);
	query.bindValue(6, notrewrite);
	query.bindValue(7, reWrite);
	query.bindValue(8, exDate);
	query.bindValue(9, ex_Date_Copy);
	query.bindValue(10, condition);
	query.bindValue(11, exSize);
	query.bindValue(12, condition_2);
	query.bindValue(13, ex_Size_Copy);
	query.bindValue(14, sizeCombo);
	query.bindValue(15, do_before);
	query.bindValue(16, execute_before);
	query.bindValue(17, execute_before_cmd);
	query.bindValue(18, execute_before_dir);
	query.bindValue(19, do_after);
	query.bindValue(20, execute_after);
	query.bindValue(21, execute_after_cmd);
	query.bindValue(22, execute_after_dir);
	query.bindValue(23, cmp_md5);
	query.bindValue(24, noRecursive);
	query.bindValue(25, index);

	if (!query.exec())
	{
	 QMessageBox::information(this, "","  . (  INSERT_NEW_RECORD)");
	 return -1;
	}
	else
	{
		query.first();
		new_index = query.value(0).toLongLong();
		query.clear();

		add_filter_item(new_index, ext, "ext" );
		add_filter_item(new_index, files, "files" );
		add_filter_item(new_index, dirs, "dirs" );
		set_last_run_time(new_index);

		//add_tsk->close();
	}
	update_table();

	ui.tableWidget->setUpdatesEnabled(false);
	for (int row=0;row<ui.tableWidget->rowCount();row++)
	{
		if (new_index == ui.tableWidget->item(row,0)->data(2).toLongLong())
		{
			ui.tableWidget->setCurrentCell(row,1);
			break;
		}
	}
	ui.tableWidget->setUpdatesEnabled(true);

	return new_index;
}

void new_scheduller::edit_data(const qint64 &my_index, const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, 
	const QString &name_add_dir, const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, 
	const int &condition, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, 
	const int &condition_2, const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, 
	const QString &execute_before_cmd, const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, 
	const QString &execute_after_dir, const int &cmp_md5, const bool &noRecursive, const int &index)
{		
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE UPDATE_DATA(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");	  
	query.bindValue(0, my_index);
	query.bindValue(1, taskname);
	query.bindValue(2, sourcefilesnames.join("\n"));
	query.bindValue(3, destdir);
	query.bindValue(4, create_add_dir);
	query.bindValue(5, name_add_dir);
	query.bindValue(6, docleardest);
	query.bindValue(7, notrewrite);
	query.bindValue(8, reWrite);
	query.bindValue(9, exDate);
	query.bindValue(10, ex_Date_Copy);
	query.bindValue(11, condition);
	query.bindValue(12, exSize);
	query.bindValue(13, condition_2);
	query.bindValue(14, ex_Size_Copy);
	query.bindValue(15, sizeCombo);
	query.bindValue(16, do_before);
	query.bindValue(17, execute_before);
	query.bindValue(18, execute_before_cmd);
	query.bindValue(19, execute_before_dir);
	query.bindValue(20, do_after);
	query.bindValue(21, execute_after);
	query.bindValue(22, execute_after_cmd);
	query.bindValue(23, execute_after_dir);
	query.bindValue(24, cmp_md5);
	query.bindValue(25, noRecursive);
	query.bindValue(26, index);

	if (!query.exec())
	{
		QMessageBox::information(this, "","   (  UPDATE_DATA). ");
		return;
	}

	query.clear();

	clear_filter_item(my_index,"ext");  //   
	clear_filter_item(my_index,"files");
	clear_filter_item(my_index,"dirs");

	add_filter_item(my_index, ext, "ext" );
	add_filter_item(my_index, files, "files" );
	add_filter_item(my_index, dirs, "dirs" );
	update_table();

	ui.tableWidget->setUpdatesEnabled(false);
	for (int row=0;row<ui.tableWidget->rowCount();row++)
	{
		if (my_index == ui.tableWidget->item(row,0)->data(2).toLongLong())
		{
			ui.tableWidget->setCurrentCell(row,1);
			break;
		}
	}
	ui.tableWidget->setUpdatesEnabled(true);
}

qint64 new_scheduller::add_script(const QString &name, const QString &script_text, const int &index)
{		
	qint64 new_index;
	QSqlQuery query;
	query.prepare("SELECT * FROM INSERT_NEW_SCRIPT(?,?,?)");
	query.bindValue(0, name);
	query.bindValue(1, script_text);
	query.bindValue(2, index);

	if (!query.exec())
	{
		QMessageBox::information(this, "","   (  INSERT_NEW_SCRIPT).");
		return -1;
	}
	else
	{
		query.first();
		new_index = query.value(0).toLongLong();
		query.clear();
		set_last_run_time(new_index);
		update_table();
		ui.tableWidget->setUpdatesEnabled(false);
		for (int row=0;row<ui.tableWidget->rowCount();row++)
		{
			if (new_index == ui.tableWidget->item(row,0)->data(2).toLongLong())
			{
				ui.tableWidget->setCurrentCell(row,1);
				break;
			}
		}
		ui.tableWidget->setUpdatesEnabled(true);
	}
	return new_index;
}

void new_scheduller::edit_script(const qint64 &my_index, const QString &name, const QString &script_text, const int &index)
{		
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE EDIT_SCRIPT(?,?,?,?)");
	query.bindValue(0, my_index);
	query.bindValue(1, name);
	query.bindValue(2, script_text);
	query.bindValue(3, index);

	if (!query.exec())
	{
		QMessageBox::information(this, "","   (  EDIT_SCRIPT).");
		return;
	}
	else
	{
		query.clear();
		update_table();

		ui.tableWidget->setUpdatesEnabled(false);
		for (int row=0;row<ui.tableWidget->rowCount();row++)
		{
			if (my_index == ui.tableWidget->item(row,0)->data(2).toLongLong())
			{
				ui.tableWidget->setCurrentCell(row,1);
				break;
			}
		}
		ui.tableWidget->setUpdatesEnabled(true);
	}	
}

void new_scheduller::setup_scheduler(const qint64 &index, const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
	const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
	const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time)
{		
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE SETUP_SCHEDULER(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
	query.bindValue(0, index);
	query.bindValue(1, enable_scheduler);
	query.bindValue(2, repeat_type);

	query.bindValue(3, day_1);
	query.bindValue(4, day_2);
	query.bindValue(5, day_3);
	query.bindValue(6, day_4);
	query.bindValue(7, day_5);
	query.bindValue(8, day_6);
	query.bindValue(9, day_7);

	query.bindValue(10, month_1);
	query.bindValue(11, month_2);
	query.bindValue(12, month_3);
	query.bindValue(13, month_4);
	query.bindValue(14, month_5);
	query.bindValue(15, month_6);
	query.bindValue(16, month_7);
	query.bindValue(17, month_8);
	query.bindValue(18, month_9);
	query.bindValue(19, month_10);
	query.bindValue(20, month_11);
	query.bindValue(21, month_12);

	query.bindValue(22, repeat_min);
	query.bindValue(23, start_date);
	query.bindValue(24, start_time);

	if (!query.exec())
	{
		QMessageBox::information(this, "","   (  SETUP_SCHEDULER).");
		return;
	}
	query.clear();
}

void new_scheduller::replace_all_param(const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
	const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
	const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time)
{
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE REPLACE_ALL_PARAM(?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?,?)");
	query.bindValue(0, enable_scheduler);
	query.bindValue(1, repeat_type);

	query.bindValue(2, day_1);
	query.bindValue(3, day_2);
	query.bindValue(4, day_3);
	query.bindValue(5, day_4);
	query.bindValue(6, day_5);
	query.bindValue(7, day_6);
	query.bindValue(8, day_7);

	query.bindValue(9, month_1);
	query.bindValue(10, month_2);
	query.bindValue(11, month_3);
	query.bindValue(12, month_4);
	query.bindValue(13, month_5);
	query.bindValue(14, month_6);
	query.bindValue(15, month_7);
	query.bindValue(16, month_8);
	query.bindValue(17, month_9);
	query.bindValue(18, month_10);
	query.bindValue(19, month_11);
	query.bindValue(20, month_12);

	query.bindValue(21, repeat_min);
	query.bindValue(22, start_date);
	query.bindValue(23, start_time);

	if (!query.exec())
	{
		QMessageBox::information(this, "","   (  REPLACE_ALL_PARAM).");
		return;
	}
	query.clear();
}

bool new_scheduller::start_tsk(const qint64 &index)
{
	bool start = false;
	QSqlQuery myquery;
	myquery.prepare("SELECT * FROM GET_SCHEDULER_DATA(?)");
	myquery.bindValue(0, index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_SCHEDULER_DATA)");
		return false;
	}
	else
	{
		myquery.first();
		start = myquery.value(0).toInt();
		if (!start) //   
			return false;
		else
		{
			if (!concurrent_execution || start_now) //       ....        
				return true;
			
			QDate start_date = QDate::fromString(myquery.value(22).toString(),"dd.MM.yyyy");
			QTime start_time = QTime::fromString(myquery.value(23).toString(),"HH:mm");

			QDateTime last_run = QDateTime::fromString(myquery.value(24).toString(),"dd:MM:yyyy:HH:mm:ss");
			int delta=-1;

			if (last_run.isValid())									
				//delta = QDateTime::currentDateTime().toTime_t() - last_run.toTime_t();
				 delta = qAbs(QDateTime::currentDateTime().secsTo(last_run));
			else				
				return true;

			int type = myquery.value(1).toInt();
			switch (type)
			{
			case 0: // 
				{						
					if (start_time.hour() == QTime::currentTime().hour() && start_time.minute() == QTime::currentTime().minute() 
						&& start_date == QDate::currentDate()  && delta > 60) //   .   , ..   
						return true;
				}
				break;
			case 1: //
				{
					int num_day=QDate::currentDate().dayOfWeek();				
					bool good_day  = myquery.value(num_day+1).toInt(); //  
					if (good_day && start_time.hour()==QTime::currentTime().hour() && start_time.minute()==QTime::currentTime().minute() && delta > 60)
					return true;
				}
				break;
			case 2: //
				{
					int num_month=QDate::currentDate().month();
					bool good_month  = myquery.value(num_month+8).toInt(); //  
					if (good_month && start_date.day() == QDate::currentDate().day() && start_time.hour() == QTime::currentTime().hour() 
						&& start_time.minute() == QTime::currentTime().minute() && delta > 60)
					return true;
				}
				break;
			case 3: //
				{
					if (start_time.hour() == QTime::currentTime().hour() && start_time.minute() == QTime::currentTime().minute() && 
						start_date.month() == QDate::currentDate().month() && start_date.day() ==  QDate::currentDate().day()    &&
						start_date.year() <= QDate::currentDate().year() && delta > 60)
						return true;
				}
				break;
			case 4: //  
				{
					int repeat =  myquery.value(21).toInt();
					if (delta >= repeat * 60)						
						return true;
				}
				break;
			}
		}

	}	
	return false;
}

bool new_scheduller::work() //    
{
	
	if (concurrent_execution) //      ,  
		return true;

	int delta=-1;

	if (last_run.isValid())									
		//delta = QDateTime::currentDateTime().toTime_t() - last_run.toTime_t();
		delta = qAbs(QDateTime::currentDateTime().secsTo(last_run));
	else				
		return true;

	if (repeat_type == 0)
	{
		if (start_time.time().hour() == QTime::currentTime().hour() && start_time.time().minute() == QTime::currentTime().minute() 
		&& start_date.date() == QDate::currentDate()  && delta > 60) //   .   ,  
			return true;
	}
	else
		if (repeat_type == 1)
		{
			int num_day=QDate::currentDate().dayOfWeek();			
			if (days[num_day-1] && start_time.time().hour() == QTime::currentTime().hour() 
				&& start_time.time().minute()==QTime::currentTime().minute() && delta > 60)
				return true;
		}
		else
			if (repeat_type == 2)
			{
				int num_month=QDate::currentDate().month();
				if (months[num_month-1] && start_date.date().day() == QDate::currentDate().day() && start_time.time().hour() == QTime::currentTime().hour() 
					&& start_time.time().minute() == QTime::currentTime().minute() && delta > 60)
					return true;
			}
			else
				if (repeat_type == 3)
				{
					if (start_time.time().hour() == QTime::currentTime().hour() && start_time.time().minute() == QTime::currentTime().minute() && 
						start_date.date().month() == QDate::currentDate().month() && start_date.date().day() ==  QDate::currentDate().day()    &&
						start_date.date().year() <= QDate::currentDate().year() && delta > 60)
						return true;
				}
				else
					if (repeat_type == 4)
					{
						if (delta >= repeat_min * 60)						
							return true;
					}

	return false;
}

void new_scheduller::set_last_run_time(const qint64 &index)
{
	QDateTime now = QDateTime::currentDateTime();
	QString lastrun = now.toString("dd:MM:yyyy:HH:mm:ss");

	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE SET_LAST_RUN_TIME(?,?)");
	query.bindValue(0, index);
	query.bindValue(1, lastrun);

	if (!query.exec())
	{
		WriteLnConsole("   (  SET_LAST_RUN_TIME).");
		return;
	}
	query.clear();
}

void new_scheduller::set_last_run_time_ini()
{
	settings->beginGroup("MainSetup");
	QDateTime now = QDateTime::currentDateTime();
	QString lastrun = now.toString("dd:MM:yyyy:HH:mm:ss");
	settings->setValue("last_run", lastrun);
	settings->endGroup();
	settings->sync();
}

void new_scheduller::save_setup(const int &autostart_planner, const int &concurrent_execution, const int &ext_log, const int &viewMessages, const int &currentIndex, 
	const int &Monday_1, const int &Tuesday_1, const int &Wednesday_1, const int &Thursday_1, const int &Friday_1, const int &Saturday_1, const int &Sunday_1, 
	const int & month_1_1, const int &month_1_2, const int &month_1_3, const int &month_1_4, const int &month_1_5, const int &month_1_6, const int &month_1_7, const int &month_1_8, const int &month_1_9, 
	const int &month_1_10, const int &month_1_11, const int &month_1_12, const int &repeat_min_2, const QString &dateEdit_2, const QString &timeEdit_2, const int &clear_log, 
	const int &stream_waiting, const int &copy_empty_dir, const int &do_limited_threds, const int &count_limited_threads, const int &do_add_dir, const int &doHide)
{
	settings->beginGroup("MainSetup");
	settings->setValue("autostart_planner", autostart_planner);
	settings->setValue("concurrent_execution", concurrent_execution);
	settings->setValue("do_limited_threds", do_limited_threds);
	settings->setValue("count_limited_threads", count_limited_threads);
	settings->setValue("ext_log", ext_log);
	settings->setValue("viewMessages", viewMessages);
	settings->setValue("clear_log", clear_log);
	settings->setValue("stream_waiting", stream_waiting);
	settings->setValue("copy_empty_dir", copy_empty_dir);
	settings->setValue("do_add_dir", do_add_dir);
	settings->setValue("doHide", doHide);

	settings->setValue("repeat", currentIndex);

	settings->setValue("day_1", Monday_1);
	settings->setValue("day_2", Tuesday_1);
	settings->setValue("day_3", Wednesday_1);
	settings->setValue("day_4", Thursday_1);
	settings->setValue("day_5", Friday_1);
	settings->setValue("day_6", Saturday_1);
	settings->setValue("day_7", Sunday_1);

	settings->setValue("month_1",  month_1_1);
	settings->setValue("month_2",  month_1_2);
	settings->setValue("month_3",  month_1_3);
	settings->setValue("month_4",  month_1_4);
	settings->setValue("month_5",  month_1_5);
	settings->setValue("month_6",  month_1_6);
	settings->setValue("month_7",  month_1_7);
	settings->setValue("month_8",  month_1_8);
	settings->setValue("month_9",  month_1_9);
	settings->setValue("month_10", month_1_10);
	settings->setValue("month_11", month_1_11);
	settings->setValue("month_12", month_1_12);

	settings->setValue("repeat_min", repeat_min_2);

	settings->setValue("start_date", dateEdit_2);
	settings->setValue("start_time", timeEdit_2);

	settings->endGroup();
	settings->sync();
	get_setup();
}

void new_scheduller::get_setup()
{
	days.clear();
	months.clear();

	settings->beginGroup("MainSetup");
	autostart_planner = settings->value("autostart_planner", false).toBool();
	concurrent_execution = settings->value("concurrent_execution", false).toBool();

	do_limited_threds = settings->value("do_limited_threds", false).toBool();
	count_limited_threads = settings->value("count_limited_threads", 0).toInt();

	ext_log = settings->value("ext_log", false).toBool();
	viewMessages = settings->value("viewMessages", false).toBool();
	clear_log = settings->value("clear_log", false).toBool();
	stream_waiting = settings->value("stream_waiting", false).toBool();
	copy_empty_dir = settings->value("copy_empty_dir", false).toBool();
	do_add_dir = settings->value("do_add_dir", false).toBool();
	doHide = settings->value("doHide", false).toBool();

	repeat_type = settings->value("repeat", 0).toInt();

	for (int i=1;i<=7;i++) // 
	{
		QString my_day="day_"+QString::number(i);
		days.append(settings->value(my_day, false).toBool());
	}

	for (int i=1;i<=12;i++) // 
	{
		QString my_month="month_"+QString::number(i);
		months.append(settings->value(my_month, false).toBool());
	}

	repeat_min = settings->value("repeat_min", 0).toInt();
	start_time.setTime(QTime::fromString(settings->value("start_time").toString(),"HH:mm"));
	start_date.setDate(QDate::fromString(settings->value("start_date").toString(),"dd.MM.yyyy"));
	last_run = QDateTime::fromString(settings->value("last_run").toString(),"dd:MM:yyyy:HH:mm:ss");	
	settings->endGroup();
}

void new_scheduller::add_filter_item(const qint64 &my_index, const QStandardItemModel &items, const QString &item_type)
{
	QSqlQuery query;

	for (int i=0; i<items.rowCount(); i++)
	{
		QString my_filter_value = items.data(items.index(i,0)).toString();
		int my_filter_type = items.data(items.index(i,1)).toInt();

		if (item_type == "ext")
			query.prepare("EXECUTE PROCEDURE ADD_EXTENSIONS(?,?,?)");
		else
			if (item_type == "files")
			    query.prepare("EXECUTE PROCEDURE ADD_FILES(?,?,?)");
		    else
		        if (item_type == "dirs")
		            query.prepare("EXECUTE PROCEDURE ADD_DIRS(?,?,?)");

		query.bindValue(0, my_index);
		query.bindValue(1, my_filter_value);
		query.bindValue(2, my_filter_type);

		if (!query.exec())
		{
			WriteLnConsole("  . "+query.lastError().text());
			return;
		}

		query.clear();
	}
}

void new_scheduller::clear_filter_item(const qint64 &my_index, const QString &item_type)
{
	QSqlQuery query;

	if (item_type == "ext")
		query.prepare("EXECUTE PROCEDURE ADD_EXTENSIONS(?,?,?)");
	else
		if (item_type == "files")
			query.prepare("EXECUTE PROCEDURE ADD_FILES(?,?,?)");
		else
			if (item_type == "dirs")
				query.prepare("EXECUTE PROCEDURE ADD_DIRS(?,?,?)");

	query.bindValue(0, my_index);
	query.bindValue(1, "");
	query.bindValue(2, "");

	if (!query.exec())
	{
		WriteLnConsole("  . "+query.lastError().text());
		return;
	}

	query.clear();
}

void new_scheduller::addtsk()
{
	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())		
			return;
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->isRunning())		
			return;
	}

	add_tsk->form_clear(); 
	add_tsk->tabWidget->setCurrentIndex(0);
	add_tsk->edit = false; //   
	add_tsk->stackedWidget->setCurrentIndex(0);
	add_tsk->show();
}

void new_scheduller::copytsk_menu()
{
	    copytsk();
}

void new_scheduller::edittsk()
{	
	if (ui.tableWidget->rowCount() == 0) 
		return;

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())		
			return;
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->isRunning())		
			return;
	}

		add_tsk->edit = true; //    

		qint64 my_index=-1;
		QStringList source;
		QStandardItemModel ext, files, dirs;
		QString dest,taskname,add_dir_name,ex_Date_Copy, execute_before, execute_before_cmd, execute_before_dir, execute_after, execute_after_cmd, execute_after_dir, 
		script_text;
		int index,notRewrite,create_add_dir, cleardest, reWrite,exDate,condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;
		qint64 ex_size_copy;
		bool noRecursive = false;

		my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
		getdata(my_index, &source, &dest, &index, &taskname, &create_add_dir, &add_dir_name, &cleardest, &notRewrite, &reWrite, &exDate, &ex_Date_Copy, 
			&condition, &ext, &files, &dirs, &exSize, &condition_2, &ex_size_copy, &sizecombo, &do_before, &execute_before, &execute_before_cmd, &execute_before_dir, 
			&do_after, &execute_after, &execute_after_cmd, &execute_after_dir, &cmp_md5, &noRecursive);
        add_tsk->itemindex = my_index; //  
	
				    add_tsk->form_clear();	
				    add_tsk->stackedWidget->setCurrentIndex(index);
					//add_tsk->tabWidget->setCurrentIndex(0);
					add_tsk->task_name->setText(taskname);
					add_tsk->list_files_and_dirs->addItems(source);
					add_tsk->dest_Edit->setText(dest);
					add_tsk->noRecursive->setChecked(noRecursive);
					add_tsk->create_add_dir->setChecked(create_add_dir);
					add_tsk->additional_dir->setText(add_dir_name);
					add_tsk->clearDest->setChecked(cleardest);
					add_tsk->notRewrite->setChecked(notRewrite);
					add_tsk->reWrite->setChecked(reWrite);
					add_tsk->exDate->setChecked(exDate);

					add_tsk->conditionCombo->setCurrentIndex(condition);
					if (condition != 3)
					add_tsk->ex_Date_Copy->setDate(QDate::fromString(ex_Date_Copy,"dd.MM.yyyy"));
					else
						add_tsk->ex_Date_Copy->setDate(QDate::fromString(ex_Date_Copy,"yy"));
					
					add_tsk->exSize->setChecked(exSize);
					add_tsk->conditionCombo_2->setCurrentIndex(condition_2);
					add_tsk	->ex_Size_Copy->setText(QString::number(ex_size_copy));
					add_tsk->sizeCombo->setCurrentIndex(sizecombo);
					add_tsk->do_before->setChecked(do_before);
					add_tsk->execute_before->setText(execute_before);
					add_tsk->execute_before_cmd->setText(execute_before_cmd);
					add_tsk->execute_before_dir->setText(execute_before_dir);
					add_tsk->do_after->setChecked(do_after);
					add_tsk->execute_after->setText(execute_after);
					add_tsk->execute_after_cmd->setText(execute_after_cmd);
					add_tsk->execute_after_dir->setText(execute_after_dir);
					add_tsk->cmp_md5->setChecked(cmp_md5);
					
					for (int i=0; i<ext.rowCount(); i++)
					{
						QListWidgetItem *newItem = new QListWidgetItem;
						newItem->setData(Qt::UserRole,"ext");
						newItem->setData(Qt::UserRole+1,ext.data(ext.index(i,1)).toInt());
						newItem->setText(ext.data(ext.index(i,0)).toString());
						//newItem->setIcon(QIcon(":/icons/ext.png"));
						add_tsk->listWidget->insertItem(0, newItem);
					}

					for (int i=0; i<files.rowCount(); i++)
					{
						QListWidgetItem *newItem = new QListWidgetItem;
						newItem->setData(Qt::UserRole,"file");
						newItem->setData(Qt::UserRole+1,files.data(files.index(i,1)).toInt());
						newItem->setText(files.data(files.index(i,0)).toString());
						//newItem->setIcon(QIcon(":/icons/files.png"));
						add_tsk->listWidget->insertItem(0, newItem);
					}					
					
					for (int i=0; i<dirs.rowCount(); i++) //   
					{
						QListWidgetItem *newItem = new QListWidgetItem;
						newItem->setData(Qt::UserRole,"dir");
						newItem->setData(Qt::UserRole+1,dirs.data(dirs.index(i,1)).toInt());
						newItem->setText(dirs.data(dirs.index(i,0)).toString());
						//newItem->setIcon(QIcon(":/icons/folder.png"));
						add_tsk->listWidget->insertItem(0, newItem);
					}									
						if (add_tsk->listWidget->count()>0)
						{
														
							add_tsk->listWidget->itemAt(0,0)->setSelected(true);
							add_tsk->get_top_item_state();
						}
						add_tsk->task_name_2->setText(taskname);
						add_tsk->scriptEdior->setText(getscript(my_index));
						add_tsk->show();								
}

void new_scheduller::deltsk()
{
	
	if (Start_check())
		return;
	
	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())		
			return;
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->isRunning())		
			return;
	}
	
	if (add_tsk->isHidden())
	deleterecord();
}

void new_scheduller::plantsk()
{
	if (ui.tableWidget->rowCount() == 0) 
		return;
	qint64 my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
	get_plan_item();
	add_tsk->stackedWidget->setCurrentIndex(3);
	add_tsk->set_current_plan_items(my_index);
	add_tsk->show();
}

void new_scheduller::stop_start()
{	
	if (start_now)
	{
		QMessageBox::warning(this, tr("!"), "   !");	
		return;
	}

	QAction *mypauseaction = findChild<QAction*>("pause_action");
	if (tsktimer->isActive())
	{		
       tsktimer->stop();
	   QSplashScreen splash(QPixmap(":/icons/loader.png"));	
	   splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
	   splash.show();
	   splash.showMessage(" ()...", Qt::AlignBottom);

	   for (int i=0; i<PointerThreadsCopy.count(); i++)	   
			    PointerThreadsCopy[i]->stop();

	   for (int j = 0; j < PointerThreadsScript.count(); j++)	   				   
			   PointerThreadsScript[j]->stop();	  	  
	   
		   for (int i=0; i<PointerThreadsCopy.count(); i++)					
			   PointerThreadsCopy[i]->wait();

		   for (int i=0; i<PointerThreadsScript.count(); i++)					
			   PointerThreadsScript[i]->wait();					   
	   
	   mypauseaction->setIcon(QIcon(":/icons/play.png"));
	}
	else
	{
		if (add_tsk->isVisible())
		{
			QMessageBox::warning(this, tr("!"), "     !");	
			return;
		}		
		mypauseaction->setIcon(QIcon(":/icons/pause.png"));
		tsktimer->start(5000);
	}
}

void new_scheduller::setup()
{
	get_setup();
	add_tsk->autostart_planner->setChecked(autostart_planner);
	add_tsk->ext_log->setChecked(ext_log);
	add_tsk->viewMessages->setChecked(viewMessages);
	add_tsk->clear_log->setChecked(clear_log);
	add_tsk->stream_waiting->setChecked(stream_waiting);
	add_tsk->copy_empty_dir->setChecked(copy_empty_dir);
	add_tsk->do_limited_threds->setChecked(do_limited_threds);
	add_tsk->count_limited_threads->setValue(count_limited_threads);
	add_tsk->do_add_dir->setChecked(do_add_dir);
	add_tsk->doHide->setChecked(doHide);

	add_tsk->stackedWidget->setCurrentIndex(4);

	if (concurrent_execution)
	{
	add_tsk->enable_concurrent_execution->setChecked(concurrent_execution);
	add_tsk->label_4->setEnabled(false);
	add_tsk->comboBox_2->setEnabled(false);
	add_tsk->groupBox_12->setEnabled(false);			
	add_tsk->stackedWidget_3->setEnabled(false);
	add_tsk->show();
	return;	
	}
	else
	{
		add_tsk->disable_concurrent_execution->setChecked(!concurrent_execution);
		add_tsk->label_4->setEnabled(true);
		add_tsk->comboBox_2->setEnabled(true);
		add_tsk->groupBox_12->setEnabled(true);			
		add_tsk->stackedWidget_3->setEnabled(true);
	}	
	add_tsk->comboBox_2->setCurrentIndex(-1);
	add_tsk->comboBox_2->setCurrentIndex(repeat_type);
	add_tsk->timeEdit_2->setTime(start_time.time());
	add_tsk->dateEdit_2->setDate(start_date.date());
	add_tsk->Monday_1->setChecked(days[0]);
	add_tsk->Tuesday_1->setChecked(days[1]);
	add_tsk->Wednesday_1->setChecked(days[2]);
	add_tsk->Thursday_1->setChecked(days[3]);
	add_tsk->Friday_1->setChecked(days[4]);
	add_tsk->Saturday_1->setChecked(days[5]);
	add_tsk->Sunday_1->setChecked(days[6]);
	add_tsk->month_1_1->setChecked(months[0]);
	add_tsk->month_1_2->setChecked(months[1]);
	add_tsk->month_1_3->setChecked(months[2]);
	add_tsk->month_1_4->setChecked(months[3]);
	add_tsk->month_1_5->setChecked(months[4]);
	add_tsk->month_1_6->setChecked(months[5]);
	add_tsk->month_1_7->setChecked(months[6]);
	add_tsk->month_1_8->setChecked(months[7]);
	add_tsk->month_1_9->setChecked(months[8]);
	add_tsk->month_1_10->setChecked(months[9]);
	add_tsk->month_1_11->setChecked(months[10]);
	add_tsk->month_1_12->setChecked(months[11]);
	add_tsk->repeat_min_2->setValue(repeat_min);
	add_tsk->show();
}

void new_scheduller::backup()
{
	QString appname = mydatapath +"/gbak.exe";
	QString basename = "SCDB.FDB_"+QDateTime::currentDateTime().toString("dd_MM_yyyy_HH_mm_ss");

	     if (!QDir().exists(mydatapath+"/Backup")) 
		 if (!QDir().mkpath(mydatapath+"/Backup"))
		{
		 QMessageBox::warning(this, "!", "      "+ mydatapath+"/Backup");
		 return;
		}

	QStringList arg;
	arg             << "-backup_database" << "-verbose" << "-user"  << db.userName()
					<<"-password" << db.password() << QDir::toNativeSeparators(db.databaseName())
					<<QDir::toNativeSeparators(mydatapath+"/Backup/"+basename)
					<<"-y"
					<<QDir::toNativeSeparators(mydatapath+"/log.txt");

	QSplashScreen splash(QPixmap(":/icons/loader.png"));
	splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
	splash.show();
	splash.showMessage(" ...", Qt::AlignBottom);
	
	     if (QFile::exists(mydatapath+"/log.txt"))
		 if (!QFile::remove(mydatapath+"/log.txt"))
		{
			QMessageBox::warning(this, "!", "    "+ mydatapath+"/log.txt");
			return;
		}

	if (QProcess::execute(appname,arg) >= 0)
	{
		if (QFile::exists(mydatapath+"/Backup/"+basename))
			QMessageBox::information(this, " !", "   :\n"+QDir::toNativeSeparators(mydatapath+"\\Backup\\"+basename));
		else
			QMessageBox::warning(this, "!", "    "+mydatapath+"\\Backup\\"+basename+"\n"+"  : "+ QDir::toNativeSeparators(mydatapath+"/log.txt"));
	}
	else
		QMessageBox::warning(this, "!", "  "+ appname);
}

void new_scheduller::restore()
{		
	if (add_tsk->isVisible())
	{
		QMessageBox::warning(this, tr("!"), "     !");	
		return;
	}

	if (Start_check())
		return;
	
	if (!QFile::exists(mydatapath+"/gfix.exe") || !QFile::exists(mydatapath+"/gbak.exe"))
	{
		QMessageBox::warning(this, "!", "     - gfix.exe, gbak.exe");
		return;
	}

	if (QFile::exists(mydatapath+"/log.txt"))
		if (!QFile::remove(mydatapath+"/log.txt"))
		{
			QMessageBox::warning(this, "!", "    "+ mydatapath+"/log.txt");
			return;
		}
	
	QString backuppath = QDesktopServices::storageLocation(QDesktopServices::DataLocation)+"/exCopy/Backup/";
	QString backupfile = QFileDialog::getOpenFileName(this,tr("    "), backuppath, tr("  (*.*)"));

	if (!backupfile.isEmpty())
	{
		QString appname = mydatapath +"/gfix.exe";
		QStringList arg;
		arg             << "-shut" << "full"     << "-force"  <<"0"  <<"-user" <<db.userName()  
			            << "-pa"   <<db.password() << QDir::toNativeSeparators(db.databaseName());

		QSplashScreen splash(QPixmap(":/icons/loader.png"));
		splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
		splash.show();
		splash.showMessage("...", Qt::AlignBottom);

		update_timer->stop();		

		if (QProcess::execute(appname,arg) >= 0)
		{
			appname = mydatapath +"/gbak.exe";
			arg.clear();
			arg <<"-rep" <<"-verbose" <<"-user" <<db.userName() << "-password"  <<db.password() << QDir::toNativeSeparators(backupfile)
				<<QDir::toNativeSeparators(db.databaseName())
				<<"-y"
				<<QDir::toNativeSeparators(mydatapath+"/log.txt");

			if (QProcess::execute(appname,arg) != 0)
			{
				QMessageBox::warning(this, "!", "    "+appname+"\n"+"  : "+ QDir::toNativeSeparators(mydatapath+"/log.txt\n"+"  online  .."));
				appname = mydatapath +"/gfix.exe";
				arg.clear();
				arg << "-online" <<"-user" <<db.userName()  << "-pa" <<db.password() << QDir::toNativeSeparators(db.databaseName());
				QProcess::execute(appname,arg);
			}
			else
				QMessageBox::information(this, " !", " .   !");
		}
		else
			QMessageBox::warning(this, "!", "  "+ appname);

		update_timer->start(700);
	}
}

bool new_scheduller::Start_check()
{
	if (tsktimer->isActive())
	{
		QMessageBox::warning(this, tr("!"), "     !");	
		return true;
	}

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())		
		{
			QMessageBox::warning(this, tr("!"), "  ,   !");	
			return true;
		}
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->isRunning())		
		{
			QMessageBox::warning(this, tr("!"), "  ,   !");	
			return true;
		}
	}
	return false;
}

void new_scheduller::doAllStop()
{
	QSplashScreen splash(QPixmap(":/icons/loader.png"));
	update_timer->stop();
	QByteArray mygeom = saveGeometry();
	QByteArray mystate = saveState();

	if (!delete_Options)
{
	QFile file(mydatapath+"/size.dat");
	if (!file.open(QFile::WriteOnly)) 
	{
		QString msg = file.errorString();
		QMessageBox::warning(this, tr(""), msg);	
	} 
	else
	{
		file.putChar((uchar)mygeom.size());
		file.write(mygeom);
		file.write(mystate);
		file.close();
	}

	settings->beginGroup("Headers");
	settings->setValue("1", size_horizontalHeader_1);
	settings->setValue("2", size_horizontalHeader_2);
	settings->endGroup();
	settings->sync();	
}

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())
		{
			PointerThreadsCopy[i]->stop();	
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ...", Qt::AlignBottom);
			PointerThreadsCopy[i]->wait();
		}
	}

	for (int j = 0; j < PointerThreadsScript.count(); j++)
	{				   
		if (PointerThreadsScript[j]->isRunning())
		{
			PointerThreadsScript[j]->stop();
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ...", Qt::AlignBottom);
			PointerThreadsScript[j]->wait();		   
		}
	}

}

void new_scheduller::closeEvent( QCloseEvent * event )
{
	//QMessageBox::StandardButton ret;
	//ret=QMessageBox::question(this, "","      ?", QMessageBox::Ok | QMessageBox::Cancel);
	//if (ret==QMessageBox::Ok)
//{
	doAllStop();
	event->accept();
	qApp->quit();
//}
	//else
	//{
		//hide();
	  //  event->ignore();
	//}
}

void new_scheduller::deleterecord()
{
	QSqlQuery query;
	QModelIndex index;
    QMessageBox::StandardButton ret;

	QModelIndexList currentSelection = ui.tableWidget->selectionModel()->selectedRows();	    
	if (currentSelection.count()!=0)
	{
		ret=QMessageBox::information(this, "","     ?", QMessageBox::Ok | QMessageBox::Cancel);

		if (ret==QMessageBox::Ok)
		{
			qSort(currentSelection.begin(),currentSelection.end(),qGreater<QModelIndex>());
			foreach(index, currentSelection) 
			{
				query.prepare("EXECUTE PROCEDURE DEL_REC(?)");
				query.bindValue(0, ui.tableWidget->item(index.row(),0)->data(2).toLongLong());
				if (!query.exec())
					QMessageBox::information(this, "","   (  DEL_REC). ");				
			}
			query.clear();
			update_table();
			   if (ui.tableWidget->rowCount() != 0)
			       ui.tableWidget->setCurrentCell(0,1);
		}
		
	}
}

void new_scheduller::writeTaskStatus(qint64 indextable, const QString & text, const bool &error)
{
	if (error) //  
	{
		for (int row=0;row<ui.tableWidget->rowCount();row++)
		{
			if (indextable == ui.tableWidget->item(row,0)->data(2).toLongLong())
			{
				ui.tableWidget->item(row,2)->setData(Qt::EditRole, ",  ");
				break;
			}
		}
	}

	else
		if (text == "") //       
		{			
			if (clear_log) //  (   )       ???
				clearlog(indextable);
			
			for (int row=0;row<ui.tableWidget->rowCount();row++)
			{
				if (indextable == ui.tableWidget->item(row,0)->data(2).toLongLong())
				{
					ui.tableWidget->item(row,2)->setData(Qt::EditRole, text);
					return;
				}
			}
		}
}

void new_scheduller::save_thread_log(qint64 indextable, const QStringList & text_log)
{
	        QSqlQuery query;
			query.prepare("EXECUTE PROCEDURE WRITETASKSTATUS(?,?,?)");	  //     
			query.bindValue(0, indextable);
			query.bindValue(1, text_log.join("\n"));

			for (int row=0;row<ui.tableWidget->rowCount();row++)
			{
			   if (indextable == ui.tableWidget->item(row,0)->data(2).toLongLong())	
					if (ui.tableWidget->item(row,2)->data(Qt::EditRole).toString()=="")
					{
						ui.tableWidget->item(row,2)->setData(Qt::EditRole, "  ");
						query.bindValue(2, 0); //   
						break;
					}
			         else
						 {
							ui.tableWidget->item(row,2)->setData(Qt::EditRole, "  ");
							query.bindValue(2, 2); //   
							break;
						 }
			}

			if (!query.exec())
			{
				WriteLnConsole("    ID: "+ QString::number(indextable)+"   WRITETASKSTATUS");
				return;
			}

			query.clear();
}

void new_scheduller::clearlog(const qint64 & indextable)
{
	    QSqlQuery query;
		query.prepare("EXECUTE PROCEDURE CLEARLOG(?)");	  
		query.bindValue(0, indextable);
	
		if (!query.exec())
		{
			QMessageBox::warning(this, tr(""),"    ID: "+ QString::number(indextable)+"   CLEARLOG");
			return;
		}

		query.clear();
}

void new_scheduller::changeEvent(QEvent *event)
{
	if (event->type() == QEvent::WindowStateChange)
	{
		if (isMinimized())
		{
			event->ignore();
			emit dohidemywindow();
			return;
		}
	}	

	QMainWindow::changeEvent(event);
}

void new_scheduller::hidemywindow()
{
	hide();
}

void new_scheduller::restoremywindow()
{
	showNormal();
	raise();
	activateWindow();
    setFocus();	
}

void new_scheduller::restoremywindowfull()
{
	showMaximized();
	raise();
	activateWindow();
	setFocus();	
}

void new_scheduller::cleaErrs(const qint64 &indextable)
{
	
	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->getindex() == indextable && PointerThreadsCopy[i]->isRunning())		
		    return;
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->getindex() == indextable && PointerThreadsScript[i]->isRunning())		
			return;
	}
	
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE WRITETASKSTATUS(?,?,?)");	  
	query.bindValue(0, indextable);
	query.bindValue(1, "");
	query.bindValue(2, 3); // 

	if (!query.exec())
	{
		QMessageBox::warning(this, tr(""),"    ID: "+ QString::number(indextable)+ "   WRITETASKSTATUS");		
		return;
	}

	query.clear();

	for (int row=0;row<ui.tableWidget->rowCount();row++)
	{
		if (indextable == ui.tableWidget->item(row,0)->data(2).toLongLong())
		{
			ui.tableWidget->item(row,2)->setData(Qt::EditRole, "");
			return;
		}
	}
}

void new_scheduller::viewLog(const qint64 &myindex)
{
	QSplashScreen splash(QPixmap(":/icons/loader.png"));
	splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
	splash.show();
	splash.showMessage(" ...", Qt::AlignBottom);

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->getindex() == myindex && PointerThreadsCopy[i]->isRunning())
		{
			getstatus->messageList->clear();
		    getstatus->messageList->addItems(PointerThreadsCopy[i]->getlog());
			return;
		}
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->getindex() == myindex && PointerThreadsScript[i]->isRunning())		
		{
			getstatus->messageList->clear();
			getstatus->messageList->addItems(PointerThreadsScript[i]->getlog());
			return;
		}
	}
			
	QSqlQuery myquery;
	myquery.prepare("SELECT * FROM GETTASKSTATUS(?)");
	myquery.bindValue(0, myindex);

	if (!myquery.exec())
	{
		QMessageBox::information(0, "","    (  GETTASKSTATUS)");
		return;
	}
	else
	{
		myquery.first();
		getstatus->messageList->clear();
		getstatus->messageList->addItems(myquery.value(0).toString().trimmed().split("\n"));
	}
}

void new_scheduller::setProgress(qint64 indextable , double value_progress)
{
	for (int row=0;row<ui.tableWidget->rowCount();row++)
 {
		if (indextable == ui.tableWidget->item(row,0)->data(2).toLongLong())
	 {
			if (qRound(value_progress) <= 100)
		{
			ui.tableWidget->item(row,3)->setData(Qt::EditRole,qRound(value_progress));
			break;
		}
			else
				break;
	 }
 }
}

void new_scheduller::clearMyConsole()
{
	ui.Outtext->clear();
}

void new_scheduller::WriteLnConsole(const QString &message)
{
	ui.Outtext->insertPlainText(message+"\n");
	ui.Outtext->moveCursor(QTextCursor::End);
}

void new_scheduller::WriteConsole(const QString &message)
{
	ui.Outtext->insertPlainText(message);
	ui.Outtext->moveCursor(QTextCursor::End);
}

void new_scheduller::getdata(const qint64 & my_index, QStringList *sourcefiles, QString *destinationdir, int *index, QString *taskname, int *create_add_dir, 
							 QString *add_dir_name, int *cleardest, int *notrewrite, int *rewrite, int *exDate, QString *ex_Date_Copy, int *condition, 
							 QStandardItemModel *ext, QStandardItemModel *files, QStandardItemModel *dirs, 
							 int *exSize, int *condition_2, qint64 *ex_size_copy, int *sizecombo, 
							 int *do_before, QString *execute_before, QString *execute_before_cmd, QString *execute_before_dir,
							 int *do_after, QString *execute_after, QString *execute_after_cmd, QString *execute_after_dir, int *cmp_md5, bool *noRecursive)
{
	
	ext->clear();
	files->clear();
	dirs->clear();
		
	ext->setColumnCount(2);
	files->setColumnCount(2);
	dirs->setColumnCount(2);

	QSqlQuery myquery;
	myquery.prepare("SELECT * FROM GET_DATA(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_DATA)");
		return;
	}
	else
	{
		myquery.first();

		if (!myquery.value(0).toString().trimmed().isNull())	//      	
		*sourcefiles = myquery.value(0).toString().trimmed().split("\n"); // 

		*destinationdir = myquery.value(1).toString().trimmed(); // 
		*index = myquery.value(2).toInt(); //  (  , )
		*taskname = myquery.value(3).toString().trimmed();// 
		*create_add_dir = myquery.value(4).toInt(); //   
		*add_dir_name = myquery.value(5).toString().trimmed(); //    
		*cleardest = myquery.value(6).toInt(); //   - 
		*notrewrite = myquery.value(7).toInt(); //   
		*rewrite = myquery.value(8).toInt(); // -  
		*exDate = myquery.value(9).toInt(); //     
		*ex_Date_Copy = myquery.value(10).toString().trimmed(); //  ,    
		*condition = myquery.value(11).toInt(); //   ,     (< > =)
		*exSize = myquery.value(12).toInt(); //   "    "
		*condition_2 = myquery.value(13).toInt(); //    
		*ex_size_copy = myquery.value(14).toLongLong(); //  
		*sizecombo = myquery.value(15).toInt(); // (   ..)
		*do_before = myquery.value(16).toInt(); //    
		*execute_before = myquery.value(17).toString();// 
		*execute_before_cmd = myquery.value(18).toString();//   
		*execute_before_dir = myquery.value(19).toString();//   
		*do_after = myquery.value(20).toInt();//    
		*execute_after  = myquery.value(21).toString();// 
		*execute_after_cmd  = myquery.value(22).toString();// 
		*execute_after_dir  = myquery.value(23).toString();//
		*cmp_md5 = myquery.value(24).toInt();//  MD5
		*noRecursive = myquery.value(25).toInt(); //    ,  
		myquery.clear();
	}

	myquery.prepare("SELECT * FROM GET_EXT(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_EXT)");
		return;
	}
	else
	{			
		while ( myquery.next() )
		{
			ext->insertRow(0);
			ext->setData(ext->index(0,0),myquery.value(0).toString().trimmed().split("\n")); // 		
			ext->setData(ext->index(0,1),myquery.value(1).toInt());
		}

		myquery.clear();
	}

	myquery.prepare("SELECT * FROM GET_FILES(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_FILES)");
		return;
	}
	else
	{			
		while ( myquery.next() )
		{
			files->insertRow(0);
			files->setData(files->index(0,0),myquery.value(0).toString().trimmed().split("\n")); // 
			files->setData(files->index(0,1),myquery.value(1).toInt());
		}

		myquery.clear();
	}

	myquery.prepare("SELECT * FROM GET_DIRS(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_DIRS)");
		return;
	}
	else
	{			
		while ( myquery.next() )
		{
			dirs->insertRow(0);
			dirs->setData(dirs->index(0,0),myquery.value(0).toString().trimmed().split("\n")); // 
			dirs->setData(dirs->index(0,1),myquery.value(1).toInt());
		}
		
		myquery.clear();
	}

}

int new_scheduller::get_task_type(const qint64 &my_index)
{
	QSqlQuery myquery;
	int task_type;
	myquery.prepare("SELECT * FROM GET_TASK_TYPE(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_TASK_TYPE)");
		return -1;
	}

	else
	{
		myquery.first();
		task_type = myquery.value(0).toInt();
	}

	myquery.clear();
	return task_type;		
}

QString new_scheduller::getscript(const qint64 & my_index)
{
	QSqlQuery myquery;
	QString script_text;
	myquery.prepare("SELECT * FROM GET_SCRIPT(?)");
	myquery.bindValue(0, my_index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_SCRIPT)");
		return "    ";
	}
	else
	{
		myquery.first();
		script_text = myquery.value(0).toString().trimmed();
	}
	myquery.clear();
	return script_text;		
}

void new_scheduller::runtsk()
{
	if (ui.tableWidget->rowCount() == 0) 
		return;

	if (tsktimer->isActive())
	{
		QMessageBox::warning(this, tr("!"), "      !");	
		return;
	}

	if (add_tsk->isVisible())
	{
		QMessageBox::warning(this, tr("!"), "     !");	
		return;
	}

	qint64 my_index=-1;
	QStringList source;
	QStandardItemModel ext, files, dirs;
	QString dest,taskname,add_dir_name,ex_Date_Copy, execute_before, execute_before_cmd, execute_before_dir,  execute_after, execute_after_cmd, execute_after_dir;
	int index,notRewrite,create_add_dir, cleardest,reWrite,exDate, condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;
	qint64 ex_size_copy;
	bool noRecursive = false;

	my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
	int task_type = get_task_type(my_index);

	//if (!start_tsk(my_index))							        //        
		//return;

	if (task_type == 1)
	{		
		for (int i=0; i<PointerThreadsCopy.count(); i++)
		{
			if (PointerThreadsCopy[i]->getindex() == my_index)
			{
				if (PointerThreadsCopy[i]->isRunning())
					return;
			}
		}
		
		getdata(my_index, &source, &dest, &index, &taskname, &create_add_dir, &add_dir_name, &cleardest, &notRewrite, &reWrite, &exDate, 
			&ex_Date_Copy, &condition, &ext, &files, &dirs, &exSize, &condition_2, &ex_size_copy, &sizecombo, &do_before, &execute_before, &execute_before_cmd, &execute_before_dir,
			&do_after, &execute_after, &execute_after_cmd, &execute_after_dir, &cmp_md5, &noRecursive);

		myThreadCopy = new ThreadCopy();

		myThreadCopy->setData(taskname, source, dest, my_index, create_add_dir, add_dir_name, cleardest, notRewrite, reWrite, exDate, ex_Date_Copy, condition, ext, 
			files, dirs, exSize, condition_2, ex_size_copy, sizecombo, do_before, execute_before, execute_before_cmd, execute_before_dir, do_after, 
			execute_after, execute_after_cmd, execute_after_dir, cmp_md5, ext_log, viewMessages, clear_log, stream_waiting, copy_empty_dir, do_add_dir, noRecursive);	

		PointerThreadsCopy.append(myThreadCopy);
		connect(myThreadCopy, SIGNAL(setTaskStatus(qint64, const QString &, const bool &)), this, SLOT(writeTaskStatus(const qint64 &, const QString &, const bool &)));
		connect(myThreadCopy, SIGNAL(save_thread_log(qint64, const QStringList &)), this, SLOT(save_thread_log(qint64, const QStringList &)));
		connect(myThreadCopy, SIGNAL(setPercent(qint64, double)), this, SLOT(setProgress (qint64, double)));
		connect(myThreadCopy, SIGNAL(thread_stopped(qint64)), this, SLOT(delete_thread(qint64)));
		connect(myThreadCopy, SIGNAL(WriteLnConsole(const QString &)), this, SLOT(WriteLnConsole(const QString &)));	
		myThreadCopy->dostart();			
	}
	
if (task_type == 2)
	{
		//if (!start_tsk(my_index))							        //        
		//	return;

		for (int j=0; j<PointerThreadsScript.count(); j++)
		{
			if (PointerThreadsScript[j]->getindex() == my_index)  //       
			{
				if (PointerThreadsScript[j]->isRunning())					
				return;
			}
		}		
			my_script = new ThreadScript;
			my_script->setData(getscript(my_index), my_index);

			PointerThreadsScript.append(my_script);
			connect(my_script, SIGNAL(setTaskStatus(qint64, const QString &, const bool &)), this, SLOT(writeTaskStatus(qint64, const QString &, const bool &)));
			connect(my_script, SIGNAL(save_thread_log(qint64, const QStringList &)), this, SLOT(save_thread_log(qint64, const QStringList &)));
			connect(my_script, SIGNAL(thread_stopped(qint64)), this, SLOT(delete_thread(qint64)));
			connect(my_script->my_ScriptWrapper, SIGNAL(clearMyConsole()), this, SLOT(clearMyConsole()));
			connect(my_script->my_ScriptWrapper, SIGNAL(WriteLnConsole(const QString &)), this, SLOT(WriteLnConsole(const QString &)));
			connect(my_script->my_ScriptWrapper, SIGNAL(WriteConsole(const QString &)), this, SLOT(WriteConsole(const QString &)));
			connect(my_script->my_ScriptWrapper, SIGNAL(showMyMessage(const QString &)), this, SLOT(showMyMessage(const QString &)));
			connect(this, SIGNAL(stopScriptWrapper()), my_script->my_ScriptWrapper, SLOT(quit()));
			my_script->dostart();			
	}
}

void new_scheduller::stoptsk()
{
	QModelIndexList currentSelection = ui.tableWidget->selectionModel()->selectedRows();	    
	if (currentSelection.count()==0)
		return;

	quint64 my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();

	for (int i=0; i<PointerThreadsCopy.count(); i++)
	{
		if (PointerThreadsCopy[i]->getindex() == my_index && PointerThreadsCopy[i]->isRunning())
		{
			PointerThreadsCopy[i]->stop();
			QSplashScreen splash(QPixmap(":/icons/loader.png"));	
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ...", Qt::AlignBottom);
			PointerThreadsCopy[i]->wait();
			break;
		}
	}
	for (int j = 0; j < PointerThreadsScript.count(); j++)
	{				   
		if (PointerThreadsScript[j]->getindex() == my_index && PointerThreadsScript[j]->isRunning())
		{
			PointerThreadsScript[j]->stop();
			QSplashScreen splash(QPixmap(":/icons/loader.png"));
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ...", Qt::AlignBottom);
			PointerThreadsScript[j]->wait();		   
		}
	}
}

void new_scheduller::show_hide_console()
{
	ui.dockWidget_2->show();
}

void new_scheduller::show_bar()
{
	ui.toolBar->show();
}

void new_scheduller::copytsk()
{	
	QModelIndexList currentSelection = ui.tableWidget->selectionModel()->selectedRows();	    
	if (currentSelection.count()==0)
		return;

	qint64 my_index=-1, index_new_record = -1;
	QStringList source;
	QStandardItemModel ext, files, dirs;
	QString dest,taskname,add_dir_name,ex_Date_Copy, execute_before, execute_before_cmd, execute_before_dir, execute_after, 
		execute_after_cmd, execute_after_dir, text_script;
	int index,notRewrite,create_add_dir, cleardest,reWrite,exDate, condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;
	qint64 ex_size_copy;
	bool noRecursive = false;

	my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
	int task_type = get_task_type(my_index);

	getdata(my_index, &source, &dest, &index, &taskname, &create_add_dir, &add_dir_name, &cleardest, &notRewrite, &reWrite, &exDate, 
		&ex_Date_Copy, &condition, &ext, &files, &dirs, &exSize, &condition_2, &ex_size_copy, &sizecombo, &do_before, &execute_before, &execute_before_cmd, 
		&execute_before_dir, &do_after, &execute_after, &execute_after_cmd, &execute_after_dir, &cmp_md5, &noRecursive);
	taskname = taskname + " ";

	if (task_type == 1)
	{

		index_new_record = add_data(taskname, source, dest, create_add_dir, add_dir_name, cleardest, notRewrite, reWrite, exDate, ex_Date_Copy, condition, ext, files, dirs, 
			exSize, condition_2, QString::number(ex_size_copy), sizecombo, do_before, execute_before, execute_before_cmd, execute_before_dir, do_after, 
			execute_after, execute_after_cmd, execute_after_dir, cmp_md5, noRecursive, task_type);
	}
	else
		if (task_type == 2)
		{
			text_script = getscript(my_index);
			index_new_record = add_script(taskname, text_script, task_type);
		}

		int enable_scheduler, repeat_type, day_1, day_2, day_3, day_4, day_5, day_6, day_7, month_1, month_2, month_3, month_4, month_5, month_6, month_7, month_8, 
			month_9, month_10, month_11, month_12, repeat_min;
		QString start_date, start_time;

		get_sheduller_data(my_index, &enable_scheduler, &repeat_type, &day_1, &day_2, &day_3, &day_4, &day_5, &day_6, &day_7,
			&month_1, &month_2, &month_3, &month_4, &month_5, &month_6, &month_7, &month_8, &month_9, &month_10, &month_11, &month_12, 
			&repeat_min,  &start_date, &start_time);

		setup_scheduler(index_new_record, 0, repeat_type, day_1, day_2, day_3, day_4, day_5, day_6, day_7, 
			month_1, month_2, month_3, month_4, month_5, month_6, month_7, month_8,
			month_9, month_10, month_11, month_12, repeat_min, start_date, start_time);
}

void new_scheduller::show_err()
{
	if (ui.tableWidget->rowCount() == 0) 
		return;

	qint64 my_index = ui.tableWidget->item(ui.tableWidget->currentItem()->row(),0)->data(2).toLongLong();
	getstatus->myindex = my_index;
	getstatus->show();	
}

bool new_scheduller::get_sheduller_data(const qint64 &index, int *enable_scheduler,int *repeat_type,int *day_1, int *day_2, int *day_3, int *day_4, int *day_5, int *day_6, int *day_7,
	int *month_1, int *month_2, int *month_3, int *month_4, int *month_5, int *month_6, int *month_7, int *month_8, int *month_9, int *month_10,
	int *month_11,int *month_12, int *repeat_min, QString *start_date, QString *start_time)
{
	QSqlQuery myquery;
	myquery.prepare("SELECT * FROM GET_SCHEDULER_DATA(?)");
	myquery.bindValue(0, index);

	if (!myquery.exec())
	{
		WriteLnConsole("   (  GET_SCHEDULER_DATA)");
		return false;
	}
	else
	{
	myquery.first();
	*enable_scheduler = myquery.value(0).toInt();
	*repeat_type = myquery.value(1).toInt();
	*day_1 = myquery.value(2).toInt();
	*day_2 = myquery.value(3).toInt();
	*day_3 = myquery.value(4).toInt();
	*day_4 = myquery.value(5).toInt();
	*day_5 = myquery.value(6).toInt();
	*day_6 = myquery.value(7).toInt();
	*day_7 = myquery.value(8).toInt();

	*month_1 = myquery.value(9).toInt();
	*month_2 = myquery.value(10).toInt();
	*month_3 = myquery.value(11).toInt();
	*month_4 = myquery.value(12).toInt();
	*month_5 = myquery.value(13).toInt();
	*month_6 = myquery.value(14).toInt();
	*month_7 = myquery.value(15).toInt();
	*month_8 = myquery.value(16).toInt();
	*month_9 = myquery.value(17).toInt();
	*month_10 = myquery.value(18).toInt();
	*month_11 = myquery.value(19).toInt();
	*month_12 = myquery.value(20).toInt();
	*repeat_min = myquery.value(21).toInt();
	*start_date = myquery.value(22).toString();
	*start_time = myquery.value(23).toString();
	}
	return true;
}

void new_scheduller::save_to_file()
{
	QModelIndexList currentSelection = ui.tableWidget->selectionModel()->selectedRows();
	if (currentSelection.count()!=0)
	{
		bool ok;
		QString export_file = QInputDialog::getText(this, tr("  :"),"", QLineEdit::Normal, "", &ok);
		if (!ok)
			return;

		QFile file(export_file);
		if (!file.open(QIODevice::WriteOnly)) 
		{
			QMessageBox::critical(this, "    !", file.errorString());
			return;
		}

		QSplashScreen splash(QPixmap(":/icons/loader.png"));
		splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
		splash.show();
		splash.showMessage(" ...", Qt::AlignBottom);

		QXmlStreamWriter stream(&file);
		stream.setAutoFormatting(true);
		stream.writeStartDocument();
		stream.writeStartElement("TASKS");

		qint64 my_index=-1;
		QStringList source, ext_, files_, dirs_;
		QString dest,taskname,add_dir_name,ex_Date_Copy, execute_before, execute_before_cmd, execute_before_dir, execute_after, 
			execute_after_cmd, execute_after_dir, text_script;
		QStandardItemModel ext, files, dirs;
		int index,notRewrite,create_add_dir, cleardest,reWrite,exDate, condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;
		qint64 ex_size_copy;
		bool noRecursive = false;

		int enable_scheduler, repeat_type, day_1, day_2, day_3, day_4, day_5, day_6, day_7, month_1, month_2, month_3, month_4, month_5, month_6, month_7, month_8, 
			month_9, month_10, month_11, month_12, repeat_min;
		QString start_date, start_time;

		qSort(currentSelection.begin(),currentSelection.end(),qGreater<QModelIndex>());
		for (int i = 0; i < currentSelection.count(); ++i)
		{
			my_index = ui.tableWidget->item(currentSelection.at(i).row(),0)->data(2).toLongLong();	

			getdata(my_index, &source, &dest, &index, &taskname, &create_add_dir, &add_dir_name, &cleardest, &notRewrite, &reWrite, &exDate, 
				&ex_Date_Copy, &condition, &ext, &files, &dirs, &exSize, &condition_2, &ex_size_copy, &sizecombo, &do_before, &execute_before, &execute_before_cmd, 
				&execute_before_dir, &do_after, &execute_after, &execute_after_cmd, &execute_after_dir, &cmp_md5, &noRecursive);

			get_sheduller_data(my_index, &enable_scheduler, &repeat_type, &day_1, &day_2, &day_3, &day_4, &day_5, &day_6, &day_7,
				&month_1, &month_2, &month_3, &month_4, &month_5, &month_6, &month_7, &month_8, &month_9, &month_10, &month_11, &month_12, 
				&repeat_min,  &start_date, &start_time);

			stream.writeStartElement("TASK_DATA");
			stream.writeTextElement("source", source.join("\n"));
			stream.writeTextElement("dest", dest);
			stream.writeTextElement("task_type", QString::number(index));
			stream.writeTextElement("taskname", taskname);
			stream.writeTextElement("create_add_dir", QString::number(create_add_dir));
			stream.writeTextElement("add_dir_name", add_dir_name);
			stream.writeTextElement("cleardest", QString::number(cleardest));
			stream.writeTextElement("notRewrite", QString::number(notRewrite));
			stream.writeTextElement("reWrite", QString::number(reWrite));
			stream.writeTextElement("exDate", QString::number(exDate));
			stream.writeTextElement("ex_Date_Copy", ex_Date_Copy);
			stream.writeTextElement("condition", QString::number(condition));

			ext_.clear();
			files_.clear();
			dirs_.clear();

			for (int i1=0; i1<ext.rowCount(); i1++)
			{
				ext_ << ext.data(ext.index(i1,0)).toString();
				ext_ << ext.data(ext.index(i1,1)).toString();
			}
			stream.writeTextElement("ext", ext_.join("\n"));

			for (int i2=0; i2<files.rowCount(); i2++)
			{
				files_ << files.data(files.index(i2,0)).toString();
				files_ << files.data(files.index(i2,1)).toString();
			}
			stream.writeTextElement("files", files_.join("\n"));

			for (int i3=0; i3<dirs.rowCount(); i3++)
			{
				dirs_ << dirs.data(dirs.index(i3,0)).toString();
				dirs_ << dirs.data(dirs.index(i3,1)).toString();
			}
			stream.writeTextElement("dirs", dirs_.join("\n"));

			stream.writeTextElement("exSize", QString::number(exSize));
			stream.writeTextElement("condition_2", QString::number(condition_2));
			stream.writeTextElement("ex_size_copy", QString::number(ex_size_copy));
			stream.writeTextElement("sizecombo", QString::number(sizecombo));
			stream.writeTextElement("do_before", QString::number(do_before));
			stream.writeTextElement("execute_before", execute_before);
			stream.writeTextElement("execute_before_cmd", execute_before_cmd);
			stream.writeTextElement("execute_before_dir", execute_before_dir);
			stream.writeTextElement("do_after", QString::number(do_after));
			stream.writeTextElement("execute_after", execute_after);
			stream.writeTextElement("execute_after_cmd", execute_after_cmd);
			stream.writeTextElement("execute_after_dir", execute_after_dir);
			stream.writeTextElement("cmp_md5", QString::number(cmp_md5));
			stream.writeTextElement("noRecursive", QString::number(noRecursive));
			stream.writeEndElement();

			stream.writeStartElement("TASK_PLAN");
			stream.writeTextElement("enable_scheduler", QString::number(enable_scheduler));
			stream.writeTextElement("repeat_type", QString::number(repeat_type));
			stream.writeTextElement("day_1", QString::number(day_1));
			stream.writeTextElement("day_2", QString::number(day_2));
			stream.writeTextElement("day_3", QString::number(day_3));
			stream.writeTextElement("day_4", QString::number(day_4));
			stream.writeTextElement("day_5", QString::number(day_5));
			stream.writeTextElement("day_6", QString::number(day_6));
			stream.writeTextElement("day_7", QString::number(day_7));
			stream.writeTextElement("month_1", QString::number(month_1));
			stream.writeTextElement("month_2", QString::number(month_2));
			stream.writeTextElement("month_3", QString::number(month_3));
			stream.writeTextElement("month_4", QString::number(month_4));
			stream.writeTextElement("month_5", QString::number(month_5));
			stream.writeTextElement("month_6", QString::number(month_6));
			stream.writeTextElement("month_7", QString::number(month_7));
			stream.writeTextElement("month_8", QString::number(month_8));
			stream.writeTextElement("month_9", QString::number(month_9));
			stream.writeTextElement("month_10", QString::number(month_10));
			stream.writeTextElement("month_11", QString::number(month_11));
			stream.writeTextElement("month_12", QString::number(month_12));
			stream.writeTextElement("repeat_min", QString::number(repeat_min));
			stream.writeTextElement("start_date", start_date);
			stream.writeTextElement("start_time", start_time);
			stream.writeEndElement();
		}

		stream.writeEndElement();
		stream.writeEndDocument();
		file.close();
		QMessageBox::information(this, tr(" "), " " +QFileInfo(file.fileName()).absoluteFilePath()+ "  !");
	}
	else
		QMessageBox::information(this, tr(" !"), "  .");

}

void new_scheduller::restore_from_file()
{
	QString import_file = QFileDialog::getOpenFileName(this,tr("    "), "");

	if (!import_file.isEmpty())
	{
		QFile file(import_file);

		if (!file.open(QIODevice::ReadOnly | QFile::Text)) 
		{
			QMessageBox::critical(this, "    !", file.errorString());
			return;
		}

		QStringList source, ext_, files_, dirs_;
		QString dest,taskname,add_dir_name,ex_Date_Copy,execute_before, execute_before_cmd, execute_before_dir, execute_after, 
			execute_after_cmd, execute_after_dir;
		int task_type,notRewrite,create_add_dir, cleardest,reWrite,exDate, condition, exSize, condition_2, sizecombo, do_before, do_after, cmp_md5;

		qint64 ex_size_copy, index_new_record;
		bool noRecursive;

		int enable_scheduler, repeat_type, day_1, day_2, day_3, day_4, day_5, day_6, day_7, month_1, month_2, month_3, month_4, month_5, month_6, month_7, month_8, 
			month_9, month_10, month_11, month_12, repeat_min;
		QString start_date, start_time;

		QSplashScreen splash(QPixmap(":/icons/loader.png"));
		splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
		splash.show();
		splash.showMessage(" ", Qt::AlignBottom);

		QXmlStreamReader reader(&file);
		while (!reader.atEnd()) 
		{
			reader.readNext();
			if (reader.isStartElement())
			{								 
					while (reader.name().toString() != "TASK_PLAN" && !reader.atEnd())
					{		
						 if (reader.isStartElement())
						 {
						  if (reader.name().toString()=="source")
						      source = reader.readElementText().trimmed().split("\n");						 
						  else
						  if (reader.name().toString()=="dest")
							  dest = reader.readElementText();
						  else
						  if (reader.name().toString()=="task_type")
							  task_type = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="taskname")
							  taskname = reader.readElementText();
						  else
						  if (reader.name().toString()=="create_add_dir")
							  create_add_dir = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="add_dir_name")
							  add_dir_name = reader.readElementText();
						  else
						  if (reader.name().toString()=="cleardest")
							  cleardest = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="notRewrite")
							  notRewrite = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="reWrite")
							  reWrite = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="exDate")
							  exDate = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="ex_Date_Copy")
							  ex_Date_Copy = reader.readElementText();
						  else
						  if (reader.name().toString()=="condition")
							  condition = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="ext")
							  ext_ = reader.readElementText().trimmed().split("\n");
						  else
						  if (reader.name().toString()=="files")
							  files_ = reader.readElementText().trimmed().split("\n");
						  else
						  if (reader.name().toString()=="dirs")
							  dirs_ = reader.readElementText().trimmed().split("\n");
						  else
						  if (reader.name().toString()=="exSize")
							  exSize = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="condition_2")
							  condition_2 = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="ex_size_copy")
							  ex_size_copy = reader.readElementText().toLongLong();
						  else
						  if (reader.name().toString()=="sizecombo")
							  sizecombo = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="do_before")
							  do_before = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="execute_before")
							  execute_before = reader.readElementText();
						  else
						  if (reader.name().toString()=="execute_before_cmd")
							  execute_before_cmd = reader.readElementText();
						  else
						  if (reader.name().toString()=="execute_before_dir")
							  execute_before_dir = reader.readElementText();
						  else
						  if (reader.name().toString()=="do_after")
							  do_after = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="execute_after")
							  execute_after = reader.readElementText();
						  else
						  if (reader.name().toString()=="execute_after_cmd")
							  execute_after_cmd = reader.readElementText();
						  else
						  if (reader.name().toString()=="execute_after_dir")
							  execute_after_dir = reader.readElementText();
						  else
						  if (reader.name().toString()=="cmp_md5")
							  cmp_md5 = reader.readElementText().toInt();
						  else
						  if (reader.name().toString()=="noRecursive")
							  noRecursive = reader.readElementText().toInt();
						 }
						  reader.readNext();
					}

						QStandardItemModel ext, files, dirs;

						ext.clear();
						files.clear();
						dirs.clear();

						ext.setColumnCount(2);
						files.setColumnCount(2);
						dirs.setColumnCount(2);

						for (int i=0; i < ext_.size()-1; ++i)
						{
							ext.insertRow(0);
							ext.setData(ext.index(0,0), ext_.at(i));
							++i;
							ext.setData(ext.index(0,1), ext_.at(i));	
						}

						for (int i=0; i < files_.size()-1; ++i)
						{
							files.insertRow(0);
							files.setData(files.index(0,0), files_.at(i));
							++i;
							files.setData(files.index(0,1), files_.at(i));	
						}

						for (int i=0; i < dirs_.size()-1; ++i)
						{
							dirs.insertRow(0);
							dirs.setData(dirs.index(0,0), dirs_.at(i));
							++i;
							dirs.setData(dirs.index(0,1), dirs_.at(i));	
						}
												
					index_new_record = add_data(taskname, source, dest, create_add_dir, add_dir_name, cleardest, notRewrite, reWrite, exDate, ex_Date_Copy, condition, ext, files, dirs, 
						exSize, condition_2, QString::number(ex_size_copy), sizecombo, do_before, execute_before, execute_before_cmd, execute_before_dir, do_after, 
						execute_after, execute_after_cmd, execute_after_dir, cmp_md5, noRecursive, task_type);

					source.clear();
					ext_.clear(); 
					files_.clear();
					dirs_.clear();	

						while (reader.name().toString() != "TASK_DATA" && !reader.atEnd())
						{
							if (reader.isStartElement())
							{
								if (reader.name().toString()=="enable_scheduler")
									enable_scheduler = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="repeat_type")
									repeat_type = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_1")
									day_1 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_2")
									day_2 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_3")
									day_3 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_4")
									day_4 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_5")
									day_5 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_6")
									day_6 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="day_7")
									day_7 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_1")
									month_1 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_2")
									month_2 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_3")
									month_3 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_4")
									month_4 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_5")
									month_5 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_6")
									month_6 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_7")
									month_7 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_8")
									month_8 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_9")
									month_9 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_10")
									month_10 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_11")
									month_11 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="month_12")
									month_12 = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="repeat_min")
									repeat_min = reader.readElementText().toInt();
								else
								if (reader.name().toString()=="start_date")
									start_date = reader.readElementText();
								else
								if (reader.name().toString()=="start_time")
									start_time = reader.readElementText();
							}
							reader.readNext();
						}
						setup_scheduler(index_new_record, enable_scheduler, repeat_type, day_1, day_2, day_3, day_4, day_5, day_6, day_7, 
							month_1, month_2, month_3, month_4, month_5, month_6, month_7, month_8,
							month_9, month_10, month_11, month_12, repeat_min, start_date, start_time);
			}
						
		}
		file.close();
		if (reader.hasError())
		{
			QMessageBox::critical(this, "   !", reader.errorString());
			return;
		}
		QMessageBox::information(this, tr(" "), "  " +QFileInfo(file.fileName()).absoluteFilePath()+ "  !");
	}
	update_table();
}

void new_scheduller::do_all_tsks()
{	
	if (work())
	start_all_tsk();
}

void new_scheduller::startnow()
{
	if (tsktimer->isActive())
	{
		QMessageBox::warning(this, tr("!"), "  !");	
		return;
	}

	if (add_tsk->isVisible())
	{
		QMessageBox::warning(this, tr("!"), "     !");	
		return;
	}

	QAction *startnow_action = findChild<QAction*>("startnow_action");
	
	start_now = !start_now;										

	if (start_now)
	{
		startnow_action->setIcon(QIcon(":/icons/stop.png"));
		start_all_tsk();
	}
	else
	{
		QSplashScreen splash;

		for (int i=0; i<PointerThreadsCopy.count(); i++)					
			PointerThreadsCopy[i]->stop();						
		
		for (int j = 0; j < PointerThreadsScript.count(); j++)			   
			PointerThreadsScript[j]->stop();
		
		    splash.setPixmap(QPixmap(":/icons/loader.png"));	
			splash.move(ui.centralWidget->parentWidget()->geometry().center().x()-(splash.width()/2), ui.centralWidget->parentWidget()->geometry().center().y()-(splash.height()/2));
			splash.show();
			splash.showMessage(" ()", Qt::AlignBottom);

			for (int i=0; i<PointerThreadsCopy.count();i++)
			{
				if (PointerThreadsCopy[i]->isRunning())				
					PointerThreadsCopy[i]->wait();				
			}

			for (int j = 0; j < PointerThreadsScript.count(); j++)
			{				   
				if (PointerThreadsScript[j]->isRunning())							
					PointerThreadsScript[j]->wait();		   				
			}
				
		startnow_action->setIcon(QIcon(":/icons/play_one.png"));
	}
}

void new_scheduller::update_interface()
{
	reconnect_bd();
	QAction *add_action = findChild<QAction*>("add_action");
	QAction *copy_action = findChild<QAction*>("copy_action");
	QAction *edit_action = findChild<QAction*>("edit_action");
	QAction *del_action = findChild<QAction*>("del_action");
	QAction *plan_action = findChild<QAction*>("plan_action");
	QAction *startnow_action = findChild<QAction*>("startnow_action");
	QAction *setup_action = findChild<QAction*>("setup_action");
	QAction *clear_action = findChild<QAction*>("clear_action");
	QAction *backup_action = findChild<QAction*>("backup_action");
	QAction *restore_action = findChild<QAction*>("restore_action");
	QAction *export_action = findChild<QAction*>("export_action");
	QAction *import_action = findChild<QAction*>("import_action");
	

	if (PointerThreadsCopy.count() >= 1 || PointerThreadsScript.count() >=1)
	{
	    qApp->processEvents();	

		add_action->setEnabled(false);		
		copy_action->setEnabled(false);		
		edit_action->setEnabled(false);		
		del_action->setEnabled(false);		
		plan_action->setEnabled(false);
		setup_action->setEnabled(false);
		clear_action->setEnabled(false);
		backup_action->setEnabled(false);
		restore_action->setEnabled(false);
		export_action->setEnabled(false);
		import_action->setEnabled(false);

		if (start_now)		
			startnow_action->setIcon(QIcon(":/icons/stop.png"));
		else
			startnow_action->setIcon(QIcon(":/icons/play_one.png"));
	}
	else
	{
		if (start_now)
			start_now = !start_now;

		add_action->setEnabled(true);		
		copy_action->setEnabled(true);		
		edit_action->setEnabled(true);		
		del_action->setEnabled(true);		
		plan_action->setEnabled(true);
		setup_action->setEnabled(true);
		clear_action->setEnabled(true);
		backup_action->setEnabled(true);
		restore_action->setEnabled(true);
		export_action->setEnabled(true);
		import_action->setEnabled(true);
		startnow_action->setIcon(QIcon(":/icons/play_one.png"));
	}
}

void new_scheduller::clear()
{

	if (ui.tableWidget->rowCount() == 0)
		return;

	for (int i=0; i<PointerThreadsCopy.count();i++)
	{
		if (PointerThreadsCopy[i]->isRunning())		
			return;
	}

	for (int i=0; i<PointerThreadsScript.count();i++)
	{
		if (PointerThreadsScript[i]->isRunning())		
			return;
	}

	QMessageBox::StandardButton ret;
	ret=QMessageBox::information(this, "","         ?", QMessageBox::Ok | QMessageBox::Cancel);

	if (ret==QMessageBox::Ok)
	{
	QSqlQuery query;
	query.prepare("EXECUTE PROCEDURE CLEAR_ALL_TASKS_STATUS");	  

	if (!query.exec())
	{
		QMessageBox::warning(this, tr(""),"   .   CLEAR_ALL_TASKS_STATUS");		
		return;
	}
	query.clear();
	update_table();
	}
}

void new_scheduller::update_fase()
{
	update_table();
}

void new_scheduller::disable_write()
{
	add_tsk->disable_write = Start_check();
}

void new_scheduller::on_tableWidget_customContextMenuRequested(QPoint)
{
	QMenu menu;
	if (PointerThreadsCopy.count() >= 1 || PointerThreadsScript.count() >=1)
	{
		menu.addAction(QIcon(":/icons/run.png"), tr("  "),this , SLOT(runtsk()));
		menu.addAction(QIcon(":/icons/stop_.png"), tr("  "),this , SLOT(stoptsk()));
		menu.addAction(QIcon(":/icons/log.png"), tr(" "),this , SLOT(show_err()));
		if (ui.dockWidget_2->isHidden())
		menu.addAction(QIcon(":/icons/console.png"), tr(" "),this , SLOT(show_hide_console()));
		if (ui.toolBar->isHidden())
			menu.addAction(QIcon(":/icons/menu.png"), tr(" "),this , SLOT(show_bar()));
	}
	else
	{
	menu.addAction(QIcon(":/icons/edit.png"), tr(""),this , SLOT(edittsk()));
	menu.addAction(QIcon(":/icons/run.png"), tr("  "),this , SLOT(runtsk()));
	menu.addAction(QIcon(":/icons/stop_.png"), tr("  "),this , SLOT(stoptsk()));
	menu.addAction(QIcon(":/icons/copy.png"),tr(""),this , SLOT(copytsk()));
	//menu.addAction(QIcon(":/icons/export.png"),tr("   XML "),this , SLOT(save_to_file()));
	//menu.addAction(QIcon(":/icons/import.png"),tr("  XML "),this , SLOT(restore_from_file()));
	menu.addAction(QIcon(":/icons/log.png"), tr(" "),this , SLOT(show_err()));
	if (ui.dockWidget_2->isHidden())
	menu.addAction(QIcon(":/icons/console.png"), tr(" "),this , SLOT(show_hide_console()));
	if (ui.toolBar->isHidden())
		menu.addAction(QIcon(":/icons/menu.png"), tr(" "),this , SLOT(show_bar()));
	}
	menu.exec(QCursor::pos());		
}

ButtonDelegate::ButtonDelegate(QWidget *parent): QItemDelegate(parent)
{
	myindex = new qint64();
}

QWidget *ButtonDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
	QPushButton *Button = new QPushButton(parent);
	connect(Button, SIGNAL(clicked()), this, SLOT(view_status()));
	return Button;
}

void ButtonDelegate::setEditorData(QWidget *editor, const QModelIndex &index) const
{
	QString value = index.model()->data(index, Qt::EditRole).toString();
	QPushButton *Button = qobject_cast<QPushButton*>(editor);
	Button->setText(value);
	*myindex = index.model()->data(index.sibling(index.row(),0)).toLongLong();		
}

void ButtonDelegate::setModelData(QWidget *editor, QAbstractItemModel *model, const QModelIndex &index) const
{
	QPushButton *Button = qobject_cast<QPushButton*>(editor);
	QString value = Button->text();
	model->setData(index, value);
}

void ButtonDelegate::updateEditorGeometry(QWidget *editor, const QStyleOptionViewItem &option, const QModelIndex &/* index */) const
{
	editor->setGeometry(option.rect);
}

void ButtonDelegate::paint(QPainter *pPainter, const QStyleOptionViewItem &option, const QModelIndex &index ) const
{			
	QPalette pal = option.palette;
	QStyleOptionViewItem  viewOption(option);

	if (index.model()->data(index, Qt::EditRole).toString() == ",  ")
		{			
			viewOption.palette.setColor(QPalette::Highlight, Qt::red);
			viewOption.palette.setColor(QPalette::HighlightedText, Qt::black);
		    pPainter->fillRect(option.rect, QColor(Qt::red));	    
		}
	else
		if (index.model()->data(index, Qt::EditRole).toString() == "")
		{
			viewOption.palette.setColor(QPalette::Highlight, Qt::darkGreen);
			viewOption.palette.setColor(QPalette::HighlightedText, Qt::black);
			pPainter->fillRect(option.rect, QColor(Qt::darkGreen));	    
		}
		else
		{
			if (index.model()->data(index, Qt::EditRole).toString() == "  ")
			{
				viewOption.palette.setColor(QPalette::Highlight, Qt::yellow);
				viewOption.palette.setColor(QPalette::HighlightedText, Qt::black);
				pPainter->fillRect(option.rect, QColor(Qt::yellow));	    
			}
		}
		   QItemDelegate::paint(pPainter, viewOption, index);		
}

void ButtonDelegate::view_status()
{			
	getstatus->myindex = *myindex;
	getstatus->show();	
}

ButtonDelegate::~ButtonDelegate()
{
	if (myindex)
	{
	delete myindex;
	myindex = 0;
	}
}

ProgressBarDelegate::ProgressBarDelegate(QWidget *parent): QItemDelegate(parent) , pixmap(QPixmap(":/icons/script.png"))
{
}

QWidget *ProgressBarDelegate::createEditor(QWidget *parent, const QStyleOptionViewItem &option, const QModelIndex &index) const
{
	return 0;
}

void ProgressBarDelegate::updateEditorGeometry(QWidget *editor,
											   const QStyleOptionViewItem &option, const QModelIndex &/* index */) const
{
	editor->setGeometry(option.rect);
}

void ProgressBarDelegate::paint(QPainter *pPainter, const QStyleOptionViewItem &option, const QModelIndex &index ) const
{
	if ( index.model()->data(index.sibling(index.row(),4)).toInt() == 1)
	{
		QVariant value = index.model()->data(index,Qt::DisplayRole);	
		QStyleOptionProgressBar opt;
		QPalette progressbarpalette(option.palette);	
		progressbarpalette.setColor( QPalette::Background, Qt::white );
		progressbarpalette.setColor( QPalette::Highlight, Qt::darkGreen ); 
		opt.palette=progressbarpalette;
		opt.rect = option.rect;
		opt.maximum=100;
		opt.minimum=0;
		opt.textVisible=true;
		opt.progress=value.toInt();
		opt.text=value.toString()+"%";
		QApplication::style()->drawControl(QStyle::CE_ProgressBar, &opt, pPainter);
	}
	else
	{		
		int x = option.rect.x() + (option.rect.width() / 2) - (pixmap.width() / 2);
		pPainter->drawPixmap(x, option.rect.y(), pixmap);
	}
	drawFocus(pPainter, option, option.rect.adjusted(0, 0, -1, -1));
}
