#ifndef NEW_SCHEDULLER_H
#define NEW_SCHEDULLER_H


#include <QtGui/QMainWindow>
#include "ui_new_scheduller.h"
#include "scripting.h"
#include <QCleanlooksStyle>
#include <QDateTime>

#include <QFile>
#include <QDir>
#include <QMessageBox>
#include <QCloseEvent>
#include <QTextCodec>
#include <QtSql>
#include <QDesktopServices>

#include <QPainter>
#include <QStyledItemDelegate>
#include <QProgressBar>
#include <QTimer>
#include <QSplashScreen>
#include <QProcess>

#include "add_task.h"
#include "copying.h"
#include "get_status.h"
#include <QSystemTrayIcon>

class my_stiker:public QLabel
{
	Q_OBJECT
public:
	my_stiker(QWidget *parent = 0);
	~my_stiker();
	QTextEdit *msg;
};


class new_scheduller : public QMainWindow
{
	Q_OBJECT

public:
	new_scheduller(QWidget *parent = 0, Qt::WFlags flags = 0);
	~new_scheduller();
	bool autostart_planner, concurrent_execution, ext_log, viewMessages, 
		 clear_log, stream_waiting, copy_empty_dir, start_now, do_limited_threds, doHide, delete_Options;
		
	int repeat_min, repeat_type, count_limited_threads, do_add_dir, size_horizontalHeader_1, size_horizontalHeader_2;
	QDateTime start_date, start_time, last_run;
	QString GetFieldType(const QString &Table, const QString &Field);
	void add_filter_item(const qint64 &, const QStandardItemModel &, const QString &);
	void clear_filter_item(const qint64 &, const QString &);
	void copy_data_files(const QString &source_path, const QString &dest_path);

private:
	Ui::new_schedullerClass ui;

protected:
	QSqlDatabase db;
	void closeEvent ( QCloseEvent * event ); 
	add_my_task *add_tsk;
	QSettings *settings;
	void update_table();
	void reconnect_bd();
	void get_plan_item();
	void deleterecord();
	void clearlog(const qint64 &);
	void changeEvent(QEvent *);
	void doAllStop();
	bool Start_check();

	ThreadCopy *myThreadCopy;
	QVector <ThreadCopy*>   PointerThreadsCopy;

	QVector<bool>days;
	QVector<bool>months;

	ThreadScript *my_script;
	QVector <ThreadScript*> PointerThreadsScript;

	void start_all_tsk();
	bool work();
	bool start_tsk(const qint64 &);
	void set_last_run_time(const qint64 &);
	void set_last_run_time_ini();

	QTimer tT;
	QEventLoop q;

	void getdata(const qint64 &, QStringList *sourcefiles, QString *destinationdir, int *index, QString *taskname, int *create_add_dir, QString *add_dir_name, int *clearDest, int *notrewrite, 
		int *rewrite, int *exDate, QString *ex_Date_Copy, int *condition, QStandardItemModel *ext, QStandardItemModel *files, QStandardItemModel *dirs, int *exSize, int *condition_2, qint64 *ex_size_copy, int *sizecombo,
		int *do_before, QString *execute_before, QString *execute_before_cmd, QString *execute_before_dir,
		int *do_after, QString *execute_after, QString *execute_after_cmd, QString *execute_after_dir, int *cmp_md5, bool *noRecursive);

	bool get_sheduller_data(const qint64 &index, int *enable_scheduler,int *repeat_type,int *day_1, int *day_2, int *day_3, int *day_4, int *day_5, int *day_6, int *day_7,
	                        int *month_1, int *month_2, int *month_3, int *month_4, int *month_5, int *month_6, int *month_7, int *month_8, int *month_9, int *month_10,
							int *month_11,int *month_12, int *repeat_min, QString *start_date, QString *start_time);

	QString getscript(const qint64 &);
	int get_task_type(const qint64 &);
	QTimer *tsktimer;
	QTimer *update_timer;
	
private slots:
	void addtsk();
	void edittsk();
	void deltsk();
	void plantsk();
	void stop_start();
	void setup();
	void backup();
	void restore();
	void do_all_tsks();
	void update_interface();
	void clear();
	void delete_thread(qint64);
	void update_fase();
	void disable_write();
	void startnow();
	void help();
	void close_app();
	void iconActivated(QSystemTrayIcon::ActivationReason reason);
	void hidemywindow();
	void restoremywindow();
	void restoremywindowfull();
	void eraseDat();
	void resize_header(int, int, int);

	qint64 add_data(const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, const QString &name_add_dir, 
		const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, const int &condition, 
		const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, const int &condition_2, 
		const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, const QString &execute_before_cmd, 
		const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, const QString &execute_after_dir, 
		const int &cmp_md5, const bool &noRecursive, const int &index);

	void edit_data(const qint64 &my_index, const QString &taskname, const QStringList &sourcefilesnames, const QString &destdir, const int &create_add_dir, 
		const QString &name_add_dir, const int &docleardest, const int &notrewrite, const int &reWrite, const int &exDate, const QString &ex_Date_Copy, 
		const int &condition, const QStandardItemModel &ext, const QStandardItemModel &files, const QStandardItemModel &dirs, const int &exSize, 
		const int &condition_2, const QString &ex_Size_Copy, const int &sizeCombo, const int &do_before, const QString &execute_before, 
		const QString &execute_before_cmd, const QString &execute_before_dir, const int &do_after, const QString &execute_after, const QString &execute_after_cmd, 
		const QString &execute_after_dir, const int &cmp_md5, const bool &noRecursive, const int &index);

	void edit_script(const qint64 &, const QString &, const QString &, const int &);
	qint64 add_script(const QString &, const QString &, const int &);

	void setup_scheduler(const qint64 &index, const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
		const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
		const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time);		

	void replace_all_param(const int &enable_scheduler, const int &repeat_type, const int &day_1, const int &day_2, const int &day_3, const int &day_4, const int &day_5,
		const int &day_6, const int &day_7, const int &month_1, const int &month_2, const int &month_3, const int &month_4, const int &month_5, const int &month_6, const int &month_7, const int &month_8,
		const int &month_9, const int &month_10, const int &month_11, const int &month_12, const int &repeat_min, const QString &start_date, const QString &start_time);		

	void save_setup(const int &autostart_planner, const int &concurrent_execution, const int &ext_log, const int &viewMessages, const int &currentIndex, 
		const int &Monday_1, const int &Tuesday_1, const int &Wednesday_1, const int &Thursday_1, const int &Friday_1, const int &Saturday_1, const int &Sunday_1, 
		const int & month_1_1, const int &month_1_2, const int &month_1_3, const int &month_1_4, const int &month_1_5, const int &month_1_6, const int &month_1_7, const int &month_1_8, const int &month_1_9, 
		const int &month_1_10, const int &month_1_11, const int &month_1_12, const int &repeat_min_2, const QString &dateEdit_2, const QString &timeEdit_2, const int &clear_log, 
		const int &stream_waiting, const int &copy_empty_dir, const int &do_limited_threds, const int &count_limited_threads, const int &do_add_dir, const int &doHide);

	void get_setup();

	void setProgress (qint64, double);
	void on_tableWidget_customContextMenuRequested(QPoint);
	void on_tableWidget_cellClicked ( int row, int column );
	void on_tableWidget_currentItemChanged ( QTableWidgetItem * current, QTableWidgetItem * previous );
	void runtsk();
	void stoptsk();
	void show_hide_console();
	void show_bar();
	void show_err();
	void copytsk();
	void save_to_file();
	void restore_from_file();
	void copytsk_menu();
    void writeTaskStatus(qint64, const QString &, const bool &);
	void save_thread_log(qint64 indextable, const QStringList & text_log);
	void clearMyConsole();
	void WriteLnConsole(const QString &);
	void WriteConsole(const QString &);
	void showMyMessage(const QString &);
	void cleaErrs(const qint64 &);
	void viewLog(const qint64 &);
	
signals:
	void stopScriptWrapper();
	void dohidemywindow();
	void dorestoremywindow();
	void dorestoremywindowfull();
};


class ButtonDelegate : public QItemDelegate
{
	Q_OBJECT

public:
	ButtonDelegate(QWidget *parent = 0);
	~ButtonDelegate();
	QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,const QModelIndex &index) const;
	void setEditorData(QWidget *editor, const QModelIndex &index) const;
	void setModelData(QWidget *editor, QAbstractItemModel *model,const QModelIndex &index) const;
	void updateEditorGeometry(QWidget *editor,const QStyleOptionViewItem &option, const QModelIndex &index) const;
	void paint(QPainter *pPainter, const QStyleOptionViewItem &option, const QModelIndex &index ) const;
	qint64 *myindex;

	private slots:
		void view_status();

};

class ProgressBarDelegate : public QItemDelegate
{
	Q_OBJECT

public:
	ProgressBarDelegate(QWidget *parent = 0);
	QWidget *createEditor(QWidget *parent, const QStyleOptionViewItem &option,const QModelIndex &index) const;
	void updateEditorGeometry(QWidget *editor,const QStyleOptionViewItem &option, const QModelIndex &index) const;
	void paint(QPainter *pPainter, const QStyleOptionViewItem &option, const QModelIndex &index ) const;

private:
	QPixmap pixmap;
};


#endif // NEW_SCHEDULLER_H
