#ifndef SCRIPTING_H
#define SCRIPTING_H

#include <QThread>
#include <QtScript>
#include <QMessageBox>
#include <QWidget>

#include "ScriptWrapper.h"


class ThreadScript: public QThread
{
	Q_OBJECT
public:
	ThreadScript(QObject *parent=0);
	~ThreadScript();
	ScriptWrapper *my_ScriptWrapper;
	void setData(const QString &, const qint64 &);
	void dostart();
	void stop();
	qint64 getindex();
	QStringList getlog();

protected:
	void run();
	QStringList my_log;

private:
	qint64 IndexThread;

	QScriptEngine *engine;
	QString script_text;

	private slots:
		void do_stopped_();

signals:
	void setTaskStatus(const qint64 &, const QString &, const bool &);
	void save_thread_log(qint64 indextable, const QStringList & text_log);
	void doscript(const QString &, const qint64 &);
	void thread_stopped(qint64);
};

#endif
